//==============================================================
// BGMt@CĐ
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "fvTool.h"
#include <psputility.h>
#include <pspaudio.h>
#include <pspmp3.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "BGM.h"
#include "charConv.h"
#include "fvView.h"
#include "sound.h"

#define MP3_BUF_SIZE		(1024 * 32 + 1472)
#define PCM_BUF_SIZE		(1152 * 32)
#define FILE_END			(0x80671402)
#define AUDIO_TIMEOUT		(5 * 1000 * 1000)					// t@C[h̃^CAEg
#define WAVE_DECODE_STEP	(1152)								// wav`ł̒PʃfR[hTCY

extern S_2CH s2ch;												// fvTool.c

typedef struct {												// BGMfR[hǗ\
	int		running;
	int		exit;												// fR[hXbh̒~w
	int		type;												// t@C̎ށi0:mp3 1:wavej
	int		swap;												// Xbvobt@̎wp
	u32		time;												// rbg[gvZp
	SceUID	fd;
	int		handle;
	strBgm	*bgm;
	char	startDir[FILE_PATH];
	char	playDir[FILE_PATH];
	char	playName[FILE_PATH];
	char	lastSDir[FILE_PATH];								// ŌɍĐt@C
	char	lastDir[FILE_PATH];									// ŌɍĐt@C
	char	lastName[FILE_PATH];								// ŌɍĐt@C
	int		full_semaid;
	int		empty_semaid;
	int		bytesDecoded;
	short	*outBuf;											// Đpwavef[^
	char	*dataBuf;											// fR[hOf[^
	short	*pcmBuf;											// fR[h
} strAudioInfo;

typedef struct {												// wavef[^Ǘ\
	unsigned int	start;										// g`f[^Jnʒu
	unsigned int	end;										// g`f[^Iʒu
	unsigned int	pos;										// Đʒu
	int				readSize;									// P񖈂ɓǂݍރTCY
	int				reset;										// ĐʒuZbgwi0:Noj
} strWavInfo;

typedef union {													// mpegwb_\
	char	cHeader[4];
	struct {
		unsigned int	sinc1:8;								// wb_(0xff)

		unsigned int	err:1;									// G[veNV
		unsigned int	layer:2;								// C
		unsigned int	id:1;									// ID
		unsigned int	sinc2:4;								// wb_(0xf)

		unsigned int	ext:1;									// GNXeVilʃtOj
		unsigned int	padding:1;								// pfBO
		unsigned int	sampling:2;								// TvO[g
		unsigned int	bitrate:4;								// rbg[g

		unsigned int	enfa:2;									// Gt@VX
		unsigned int	original:1;								// IWi^Rs[
		unsigned int	copyright:1;							// 쌠
		unsigned int	mode:2;									// [hGNXeV
		unsigned int	channel:2;								// `l[h
	} h;
} mpeg_head;

typedef union {													// mpegwb_\
	char	cHeader[16];
	struct {
		u16	formatID;											// tH[}bgID
		u16	channel;											// `l
		u32	SamplingRate;										// TvO[g
		u32	avg;												// f[^x
		u16	blockSize;											// ubNTCY
		u16	bit;												// Tṽrbg
	} h;
} wav_head;

typedef struct {
	char			*name;										// ID3^O
	unsigned char	**data;										// i[ϐւ̃|C^
} strTagList;

static int			gPlayThread;
static int			gDecodeThread;
static strAudioInfo	gAudioInfo;
static strWavInfo	gWavInfo;

strBgm		gBGM;												// BGMǗ\̂̎
strPlaylist	gPlaylist;											// BGMvCXg\̂̎


//==============================================================
// BGMvpeB̃NA
//--------------------------------------------------------------
// resetF0ȊO BGM\̂̏ݒiɂP񂾂w肷j
//--------------------------------------------------------------

void bgmPropertyClear(strBgm *bgm, int reset)
{
	int		bgmID;

	if (!reset) {												// mۂẲ
		free( bgm->title );
		free( bgm->artist );
		free( bgm->album );
		free( bgm->year );
		free( bgm->comment );
		free( bgm->info );
		if (bgm->pic) {
			strBgmPic	*pic, *pic2;
			pic = bgm->pic;
			while (pic) {
				free( pic->descText );
				free( pic->data );
				pic2 = pic;
				pic = pic->next;
				free( pic2 );
			}
		}
		bgmID = bgm->bgmID;
	} else {
		bgmID = 0;
	}
	memset( bgm, 0, sizeof(strBgm) );
	bgm->bgmID = bgmID;
	bgm->title = NULL;
	bgm->artist = NULL;
	bgm->album = NULL;
	bgm->year = NULL;
	bgm->comment = NULL;
	bgm->pic = NULL;
	bgm->info = NULL;
}


//==============================================================
// mp3ID3v2^O擾
//--------------------------------------------------------------
// textF ^Oi[ziUTF8j
// frameFID3v2t[
//--------------------------------------------------------------

//===== UTF-16̎荞 =====

static int getTagUTF16(unsigned char *text, int textSize, unsigned char *frame, unsigned int frameSize)
{
	unsigned char	utf8[4];
	int				i, textPos, bom, step;
	unsigned int	pos;

	pos = 0;
	bom = 0;													// ftHg̓rbOGfBA
	if (frame[0]==0xFF && frame[1]==0xFE) {
		bom = 1;												// gGfBA
		pos += 2;
	} else if (frame[0]==0xFE && frame[1]==0xFF) {
		bom = 0;												// rbOGfBA
		pos += 2;
	}
	textPos = 0;
	while (textPos<textSize-1 && pos<frameSize-1 && !(frame[pos]=='\0' && frame[pos+1]=='\0')) {
		if (bom) {												// gGfBA
			step = ucs2utf8( utf8, frame[pos] + (frame[pos+1]<<8) );
		} else {												// rbOGfBA
			step = ucs2utf8( utf8, (frame[pos]<<8) + frame[pos+1] );
		}
		pos += 2;
		if (textPos+step >= textSize) break;					// obt@TCY𒴂Ȃ
		for (i = 0; i < step; i++) {
			text[textPos++] = utf8[i];
		}
	}
	text[textPos] = '\0';
	if (frame[pos] == '\0') pos += 2;
	return pos;
}

//===== GR[fBO̎wɏ]UTF8ɕϊȂ荞 =====

static int getEncodeString(unsigned char *text, int textSize, unsigned char *frame, unsigned int frameSize, unsigned int pos, int codeType )
{
	int	textPos;

	switch (codeType) {
	case 0:														// ISO-8859-1 (Shift-JIS)
		pos += Sjis2UTF8Len( text, textSize, &frame[pos], frameSize-pos );
		break;

	case 1:														// UTF-16 / BOM
	case 2:														// UTF-16BE / BOMȂ
		pos += getTagUTF16( text, textSize, &frame[pos], frameSize-pos );
		break;

	case 3:														// UTF-8
		textPos = 0;
		while (textPos<textSize-1 && pos<frameSize && frame[pos]) {
			text[textPos++] = frame[pos++];
		}
		text[textPos] = '\0';
		if (frame[pos] == '\0') pos++;
		break;
	}
	return pos;
}

//===== ߍ݉摜荞 =====

static strBgmPic *getPic(SceUID fd, unsigned int frameSize, int ver, int imgFlag)
{
	unsigned char	buf[128], utf8[128];
	int				spos, mimeSize, codeType;
	unsigned int	pos;
	strBgmPic		*pic;

	pic = (strBgmPic*)malloc( sizeof(strBgmPic) );
	if (!pic) return NULL;										// ƗpmۏoȂ

	spos = sceIoRead( fd, buf, 128 );
	if (ver == 2) {												// image format̒
		mimeSize = 3;
	} else {
		mimeSize = 15;
	}
	codeType = buf[0];
	pos = 1;
	pos = getEncodeString( (u8*)pic->mime, mimeSize, buf, 128, pos, 0 );	// image format / MIME type
	if (strstr(pic->mime,"PNG") || strstr(pic->mime,"png")) {
		pic->imageType = EXT_TYPE_PNG;
	} else if (strstr(pic->mime,"JPG") || strstr(pic->mime,"jpeg")) {
		pic->imageType = EXT_TYPE_JPG;
	} else if (strstr(pic->mime,"GIF") || strstr(pic->mime,"gif")) {
		pic->imageType = EXT_TYPE_GIF;
	} else if (strstr(pic->mime,"BMP") || strstr(pic->mime,"bmp")) {
		pic->imageType = EXT_TYPE_BMP;
	}

	pic->picType = buf[pos++];									// Picture type

	pos = getEncodeString( utf8, 128, buf, 128-mimeSize, pos, codeType );
	pic->descText = malloc( strlen( (char*)utf8 ) + 1 );
	if (pic->descText) {										// Description
		strcpy( (char*)pic->descText, (char*)utf8 );
	}

	sceIoLseek32( fd, pos - spos, SEEK_CUR );					// 摜f[^̊JnʒuփV[N
	pic->dataSize = frameSize - pos;
	pic->next = NULL;
	pic->back = NULL;
	if (imgFlag) {
		pic->data = malloc( pic->dataSize );					// 摜f[^擾ꍇ
		if (pic->data) {
			fileDivRead( fd, pic->data, pic->dataSize );		// ߍ݉摜f[^ۑ
			return pic;
		} else {												// 摜f[^pmۂłȂ
			free( pic );
			sceIoLseek32( fd, pic->dataSize, SEEK_CUR );
			return NULL;
		}
	} else {													// 摜f[^擾Ȃꍇ
		pic->data = NULL;
		sceIoLseek32( fd, pic->dataSize, SEEK_CUR );
		return pic;
	}
}

//===== ^O荞 =====

static void getTag(SceUID fd, strTagList tagList, unsigned int frameSize)
{
	unsigned char	*frame, *buf, text[256];
	int				codeType;
	unsigned int	pos;

	frame = malloc( frameSize );
	if (!frame) return;											// mۏoȂ牽Ȃ
	sceIoRead( fd, frame, frameSize );

	codeType = frame[0];
	pos = 1;
	if (*tagList.name == 'C') {									// Rg
		if (codeType==1 || codeType==2) {
			while (!(frame[pos]=='\0' && frame[pos+1]=='\0') && pos<frameSize) {
				pos++;
			}
			if (frame[pos] == '\0') pos += 2;					// Zk
		} else {
			while (frame[pos]!='\0' && pos<frameSize) {
				pos++;
			}
			if (frame[pos] == '\0') pos++;						// Zk
		}
	}

	getEncodeString( text, 256, frame, frameSize, pos, codeType );
	free( frame );
	buf = malloc( strlen((char*)text) + 1 );
	if (!buf) return;
	strcpy( (char*)buf, (char*)text );
	*tagList.data = buf;
}

//===== gp^O擾 =====

static void getEtcTag(SceUID fd, unsigned int frameSize, unsigned char *tag, char *info)
{
	char			atext[256], item[4];
	unsigned char	*frame, text[64];
	int				i, codeType;
	unsigned int	pos;

	frame = malloc( frameSize + 1 );
	if (!frame) return;											// mۏoȂ牽Ȃ
	sceIoRead( fd, frame, frameSize );
	frame[frameSize] = '\0';

	codeType = frame[0];
	pos = 1;
	if (*tag == 'C') {											// Rg
		if (codeType==1 || codeType==2) {
			while (!(frame[pos]=='\0' && frame[pos+1]=='\0') && pos<frameSize) {
				pos++;
			}
			if (frame[pos] == '\0') pos += 2;					// Zk
		} else {
			while (frame[pos]!='\0' && pos<frameSize) {
				pos++;
			}
			if (frame[pos] == '\0') pos++;						// Zk
		}
	}
	if (*tag=='T' || *tag=='C') {								// eLXgn
		getEncodeString( text, 60, frame, frameSize, pos, codeType );
		sprintf( atext, "%.4s : %.60s\n", tag, text );
	} else if (*tag == 'P') {
		sprintf( atext, "%.4s : %.60s", tag, frame );
		pos = strlen( (char*)frame ) + 1;
		if (frame[pos]) {
			strcat( atext, "\n          " );
			for (i = 0; i < 8; i++ ) {
				if (pos >= frameSize) break;
				sprintf( item, " %02X", frame[pos++] );
				strcat( atext, item );
			}
			if (pos < frameSize) {
				strcat( atext, "\n          " );
				for (i = 0; i < 8; i++ ) {
					if (pos >= frameSize) break;
					sprintf( item, " %02X", frame[pos++] );
					strcat( atext, item );
				}
			}
		}
		strcat( atext, "\n" );
	} else if (*tag == 'W') {
		if (tag[1] == 'X') {									// [U[`URL
			pos = getEncodeString( text, 60, frame, frameSize, pos, codeType );
			sprintf( atext, "%.4s : %.60s\n", tag, text );
			if (frame[pos]) {
				sprintf( (char*)text, "            %.40s\n", &frame[pos] );
				strcat( atext, (char*)text );
			}
		} else {												// URLAhX
			sprintf( atext, "%.4s : %.60s\n", tag, frame );
		}
	} else {													// ̑
		sprintf( atext, "%.4s :", tag );
		pos = 0;
		for (i = 0; i < 8; i++ ) {
			if (pos >= frameSize) break;
			sprintf( item, " %02X", frame[pos++] );
			strcat( atext, item );
		}
		strcat( atext, "\n            " );
		for (i = 0; i < 8; i++ ) {
			if (pos >= frameSize) break;
			sprintf( item, " %02X", frame[pos++] );
			strcat( atext, item );
		}
		strcat( atext, "\n" );
	}
	if (strlen(info) + strlen(atext) < 1023) {
		strcat( info, atext );
	}

	free( frame );
}

//===== ID3v2t[w^O =====

static void getID3v2tag(SceUID fd, strTagList tagList[], strBgm *bgm, int imgFlag)
{
	unsigned char	frame[16];
	int				i, end, pos, tagSize;
	unsigned int	frameSize, spos;
	strBgmPic		*pic, *pic2, *pic3;

	while (1) {
		if (bgm->tag <= 2) {									// ID3v2.2
			if (sceIoRead(fd, frame, 6) != 6) return;
			frameSize = (frame[3]<<16) | (frame[4]<<8) | frame[5];
			tagSize = 3;
		} else if (bgm->tag >= 3) {								// ID3v2.3
			if (sceIoRead(fd, frame, 10) != 10) return;
			if (bgm->tag == 3) {
				frameSize = (frame[4]<<24) | (frame[5]<<16) | (frame[6]<<8) | frame[7];
			} else {											// ID3v2.4ȍ~
				frameSize = (frame[4]<<21) | (frame[5]<<14) | (frame[6]<<7) | frame[7];
			}
			tagSize = 4;
		}
		end = 0;
		for (i = 0; i < tagSize; i++) {
			if ( !( (frame[i]>='0' && frame[i]<='9') || (frame[i]>='A' && frame[i]<='Z') ) ) {
				end = 1;
				break;
			}
		}
		if (end) break;											// ^OɎgp镶ł͂ȂȂ珈I
		spos = sceIoLseek32( fd, 0, SEEK_CUR );					// ݂̃t@C|C^ʒu
		pos = 0;
		while (*tagList[pos].name != '\0') {
			if (strncmp((char*)frame, tagList[pos].name, tagSize) == 0) {	// Ώۃ^O𔭌
				if (pos == 0) {									// ߍ݉摜
					pic = getPic( fd, frameSize, bgm->tag, imgFlag );
					if (pic) {									// 摜f[^擾ł
						bgm->picCount++;
						if (!bgm->pic) {						// o^ς݉摜f[^ꍇiVKo^j
							bgm->pic = pic;
						} else {								// 摜f[^̒ǉo^
							pic2 = bgm->pic;
							while (1) {							// picTypeɂȂ悤ɓo^ʒu𒲂ׂ
								if (pic2->picType>pic->picType || !pic2->next ) {
									break;
								}
								pic2 = pic2->next;
							}
							if (pic2->picType > pic->picType) {
								pic3 = pic2->back;				// upic3 - pic - pic2vƈׂ悤Ƀ`FCq
								if (pic3) {
									pic3->next = pic;
									pic->back = pic3;
								}
								pic->next = pic2;
								pic2->back = pic;
							} else {							// upic2 - picvƈׂ悤Ƀ`FCq
								pic2->next = pic;
								pic->back = pic2;
							}
						}
					}
				} else {										// eLXgn
					if (imgFlag) {
						if (*tagList[pos].data) {				// ɊY^O͎擾Ă
							getEtcTag( fd, frameSize, frame, bgm->etcTag );
						} else {
							getTag( fd, tagList[pos], frameSize );
						}
					}
				}
				break;											// ^Oe荞񂾂̂Ȃ烋[vI
			}
			pos++;
		}
		if (*tagList[pos].name == '\0') {						// 擾Ȃ^O
			if (imgFlag) {
				getEtcTag( fd, frameSize, frame, bgm->etcTag );
			}
		}
		sceIoLseek32( fd, spos + frameSize, SEEK_SET );			// ̃^Oʒu
	}
}


//==============================================================
// t@CID3v2^O擾
//--------------------------------------------------------------
// offsetFID3v2^OLItZbg
// startF f[^Jnʒu
// endF   f[^Iʒu
//--------------------------------------------------------------

static void getFileID3v2(SceUID fd, int offset, strBgm *bgm, long *start, long *end, int imgFlag)
{
	unsigned char	head[12];
	unsigned int	frameSize;
	int				pos;
	strTagList		tagList[2][7] = {							// ID3^OƊi[ϐ̃Xg
		{
		  { "PIC", NULL }, { "TT2", &bgm->title }, { "TP1", &bgm->artist },
		  { "TAL", &bgm->album }, { "TYE", &bgm->year }, { "COM", &bgm->comment },
		  { "", NULL }
		}, {
		  { "APIC", NULL }, { "TIT2", &bgm->title }, { "TPE1", &bgm->artist },
		  { "TALB", &bgm->album }, { "TYER", &bgm->year }, { "COMM", &bgm->comment },
		  { "", NULL }
		}
	};

	*start = 0;
	*end = sceIoLseek32( fd, 0, SEEK_END );
	sceIoLseek32( fd, offset, SEEK_SET );
	sceIoRead( fd, head, 10 );									// ID3v2wb_ǂݍ
	if (head[0] == 'I' && head[1] == 'D' && head[2] == '3') {	// ID3v2
		bgm->tag = head[3];										// ^Oo[W
		frameSize = (head[6] << 21) | (head[7] << 14) | (head[8] << 7) | head[9];
		*start = frameSize + 10;
		pos = 0;
		if (head[5] & 0x20) {									// gwb_L
			sceIoRead( fd, head, 6 );							// gwb_
			if (bgm->tag <= 3) {								// ID3v2.3ȑOȂ
				pos = (head[0]<<24) | (head[1]<<16) | (head[2]<<8) | head[3];
			} else {											// ID3V2.4ȍ~Ȃ
				pos = (head[0]<<21) | (head[1]<<14) | (head[2]<<7) | head[3];
			}
			sceIoLseek32( fd, pos - 6, SEEK_CUR );				// gwb_͓ǂݔ΂
		}
		if (bgm->tag <= 2) {									// ID3v2.2
			getID3v2tag( fd, tagList[0], bgm, imgFlag );
		} else {												// ID3v2.3ȍ~
			getID3v2tag( fd, tagList[1], bgm, imgFlag );
		}
	}
}


//==============================================================
// t@CID3v1^O擾
//--------------------------------------------------------------
// offsetFID3v2^OLItZbg
// startF f[^Jnʒu
// endF   f[^Iʒu
//--------------------------------------------------------------

static void getFileID3v1(SceUID fd, strBgm *bgm, long *start, long *end, int imgFlag)
{
	unsigned char	head[12];
	char			buf[31], utf8[64];

	if (!imgFlag) return;

	sceIoLseek32( fd, -128, SEEK_END );
	sceIoRead( fd, head, 3 );
	if (head[0] == 'T' && head[1] == 'A' && head[2] == 'G') {	// ID3v1
		*end -= 128;
		if (bgm->tag == 0) {									// ^O擾ĂȂȂ
			bgm->tag = 1;										// ID3v1^O
			sceIoRead( fd, buf, 30 );							// ȃ^Cg
			buf[30] = '\0';
			Sjis2UTF8Len( (u8*)utf8, 64, (u8*)buf, 30 );
			bgm->title = malloc( strlen(utf8) + 1 );
			if (bgm->title) strcpy( (char*)bgm->title, utf8 );
			sceIoRead( fd, buf, 30 );							// ȃA[eBXg
			buf[30] = '\0';
			Sjis2UTF8Len( (u8*)utf8, 64, (u8*)buf, 30 );
			bgm->artist = malloc( strlen(utf8) + 1 );
			if (bgm->artist) strcpy( (char*)bgm->artist, utf8 );
			sceIoRead( fd, buf, 30 );							// ȃAo
			buf[30] = '\0';
			Sjis2UTF8Len( (u8*)utf8, 64, (u8*)buf, 30 );
			bgm->album = malloc( strlen(utf8) + 1 );
			if (bgm->album) strcpy( (char*)bgm->album, utf8 );
			sceIoRead( fd, buf, 4 );							// ȐN
			buf[4] = '\0';
			Sjis2UTF8Len( (u8*)utf8, 64, (u8*)buf, 4 );
			bgm->year = malloc( strlen(utf8) + 1 );
			if (bgm->year) strcpy( (char*)bgm->year, utf8 );
		}
	}
}


//==============================================================
// mp3t@C̃^O擾
//--------------------------------------------------------------
// imgFlagF0    ߍ݉摜f[^̐̂ݎ擾
//          ȊO S^O擾
//--------------------------------------------------------------

int getMP3FileTag(SceUID fd, strBgm *bgm, long *start, long *end, int imgFlag)
{
	char			*info;
	unsigned char	head[12];
	mpeg_head		mHead;
	const int		bitrateTbl[2][3][14] = {					// rbg[gZe[u
		{
			{ 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160 },
			{ 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160 },
			{ 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256 },
		}, {
			{ 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320 },
			{ 32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 384 },
			{ 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448 },
		}
	};
	const int		samplingTbl[2][3] = {						// TvO[gZe[u
		{ 22050, 24000, 16000 },								// mpeg2
		{ 44100, 48000, 32000 },								// mpeg1
	};

	const char	tagType[][8] = { "", "ID3v1", "ID3v2.2", "ID3v2.3", "ID3v2.4" };
	const char	layer[][10] = { "", "Layer-3", "Layer-2", "Layer-1" };
	const char	mpeg[][6] = { "MPEG-2", "MPEG-1" };
	const char	chan[][14] = { "stereo", "joint stereo", "dual channel", "monaural" };
	const char	encode[][4] = { "CBR", "VBR" };

	//----- ID3^O -----

	bgmPropertyClear( bgm, 0 );
	getFileID3v2( fd, 0, bgm, start, end, imgFlag );			// ID3v2^O擾
	getFileID3v1( fd, bgm, start, end, imgFlag );				// ID3v1^O擾
	if (bgm->tag) bgm->type = 1;								// mp3t@C

	//----- mpegt[ -----

	sceIoLseek32( fd, *start, SEEK_SET );						// mpegt[wb_ʒu
	sceIoRead( fd, mHead.cHeader, 4 );
	bgm->mID = mHead.h.id;										// mpeg2 / mpeg1
	if (bgm->mID > 1) return -1;								// tH[}bgG[
	bgm->mLayer = mHead.h.layer;								// C[
	if (mHead.h.sampling < 3) {									// TvO[g
		bgm->SamplingRate = samplingTbl[bgm->mID][mHead.h.sampling];
	} else {
		return -1;												// tH[}bgG[
	}
	if (mHead.h.bitrate > 0 && mHead.h.bitrate <= 14 && bgm->mLayer != 0) {	//rbg[g
		bgm->bitRate = bitrateTbl[bgm->mID][bgm->mLayer - 1][mHead.h.bitrate - 1];
	} else {
		return -1;												// tH[}bgG[
	}
	bgm->channel = mHead.h.channel;								// `l
	if (bgm->channel > 3) return -1;							// tH[}bgG[
	if (bgm->channel == 3) {									// mȂ
		sceIoLseek32( fd, *start +21, SEEK_SET );				// mpegt[Jnʒu
	} else {													// XeIȂ
		sceIoLseek32( fd, *start +36, SEEK_SET );				// mpegt[Jnʒu
	}
	sceIoRead( fd, head, 12 );									// <Xing>wb_͂̏ꏊ
	if (strncmp((char*)head, "Xing", 4) == 0) {					// <Xing>wb_
		if (head[7] & 0x01) {									// t[L
			bgm->vbr = 1;
			bgm->frame = (head[8]<<24) + (head[9]<<16) + (head[10]<<8) + head[11];
		}
	}

	//----- Ȃ̒ -----

	if (bgm->vbr) {												// σrbg[g̏ꍇ
		if (bgm->SamplingRate) {
			bgm->time = bgm->frame * 115200 / bgm->SamplingRate;
		}
	} else {													// Œrbg[g̏ꍇ
		if (bgm->bitRate) {
			bgm->time = (*end - *start) * 8 / bgm->bitRate / 10;
		}
	}

	//-----  -----

	if (imgFlag) {
		info = malloc( 256 );
		if (!info) return 0;
		sprintf( info, "FileType : %s\nTagType : %s\nLayer : %s\nMPEG : %s\nChannel : %s\nEncodeType : %s\nTime : %.2f",
		               "mp3", tagType[bgm->tag], layer[bgm->mLayer], mpeg[bgm->mID], chan[bgm->channel], encode[bgm->vbr], bgm->time/100.0f );
		if (bgm->frame) {
			char	buf[32];
			sprintf( buf, "\nmpegFrame : %d", bgm->frame );
			strcat( info, buf );
		}
		bgm->info = info;
	}
	return 0;
}


//==============================================================
// mp3f[^̃fR[h
//--------------------------------------------------------------

//===== fR[h =====

static int mp3Decode(strAudioInfo *audio, short *playBuf[])
{
	SceUChar8*	dst;
	int			size, pos;
	SceInt64	ret;
	short		*buf;
	u32			time;

	if (sceMp3CheckStreamDataNeeded(audio->handle) > 0) {
		if (sceMp3GetInfoToAddStreamData(audio->handle, &dst, &size, &pos) < 0) {
			return -1;
		}
		filePrefetchSeek( audio->fd, pos, SEEK_SET );
		ret = filePrefetchRead( audio->fd, dst, size );
		if (ret < 0) {
			return -1;
		}
		if (sceMp3NotifyAddStreamData(audio->handle, ret) < 0) {
			return -1;
		}
		if (audio->time > clock()) audio->time = 0;
		if (audio->time) {
			time = (clock() - audio->time) / 1000;
		} else {
			time = 0;
		}
		audio->time = clock();
		if (time) {
			audio->bgm->bitRate = ret * 8 / time;				// rbg[ǧvZ
		} else {
			audio->bgm->bitRate = 0;
		}
	}
	if (audio->bytesDecoded > 0) {
		audio->bytesDecoded = sceMp3Decode( audio->handle, &buf );
		memcpy( playBuf[audio->swap], buf, audio->bytesDecoded );
		audio->outBuf = playBuf[audio->swap];
		audio->swap = 1 - audio->swap;
	}
	return 0;
}

//===== ݒ =====

static int mp3Setup(char *path, strAudioInfo *audio, strBgm *bgm)
{
	int				ret;
	long			start, end;
	SceMp3InitArg	mp3Init;

	audio->fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
	if (audio->fd < 0) {
		return -1;
	}
	ret = getMP3FileTag( audio->fd, bgm, &start, &end, 1 );		// mp3̃^O擾
	sceIoClose( audio->fd );
	if (ret) {													// tH[}bgG[
		bgmPropertyClear( bgm, 0 );
		bgm->unsupport = 1;
		return -2;
	}

	//--- mp3̏ݒ ---

	audio->fd = filePrefetchOpen( path );
	if (audio->fd < 0) return -3;
	if (sceMp3InitResource() < 0) {
		filePrefetchClose( audio->fd );
		return -1;
	}
	mp3Init.mp3StreamStart = start;
	mp3Init.mp3StreamEnd = end;
	mp3Init.unk1 = 0;
	mp3Init.unk2 = 0;
	mp3Init.mp3Buf = audio->dataBuf;
	mp3Init.mp3BufSize = MP3_BUF_SIZE;
	mp3Init.pcmBuf = audio->pcmBuf;
	mp3Init.pcmBufSize = PCM_BUF_SIZE;
	audio->handle = sceMp3ReserveMp3Handle( &mp3Init );
	if (audio->handle < 0) {
		sceMp3TermResource();
		filePrefetchClose( audio->fd );
		return -1;
	}
	audio->type = 0;											// mp3`
	audio->bgm = bgm;
	audio->swap = 0;
	audio->bytesDecoded = 0;
	audio->exit = 0;
	audio->full_semaid = sceKernelCreateSema( "full_sema", 0, 0, 1, 0 );
	audio->empty_semaid = sceKernelCreateSema( "empty_sema", 0, 1, 1, 0 );
	sceKernelStartThread( gDecodeThread, sizeof(strAudioInfo**), &audio );
	sceKernelWaitSema( audio->full_semaid, 1, NULL );
	sceKernelSignalSema( audio->full_semaid, 0 );
	ret = sceMp3Init( audio->handle );
	if (ret < 0) {
		return -2;
	}
	audio->bytesDecoded = 1;
	sceKernelSignalSema( audio->empty_semaid, 1 );
	sceMp3SetLoopNum( audio->handle, 0 );						// -1:[v 0:Pȃ[v
	return 0;
}

//===== ĐI =====

static void mp3Playend(strAudioInfo *audio)
{
	sceMp3ReleaseMp3Handle( audio->handle );
	sceMp3TermResource();
}

//===== ĐʒuZbg =====

static void mp3Reset(strAudioInfo *audio)
{
	sceMp3ResetPlayPosition( audio->handle );
}


//==============================================================
// wavt@C̃^O擾
//--------------------------------------------------------------
// imgFlagF0    ߍ݉摜f[^̐̂ݎ擾
//          ȊO S^O擾
//--------------------------------------------------------------
// ĐɑΉĂ̂̓jAPCMi8,16,24bitjXeI܂łłB
//--------------------------------------------------------------

int getWavFileTag(SceUID fd, strBgm *bgm, long *start, long *end, int imgFlag)
{
	char			*info;
	unsigned char	head[12];
	int				len;
	long			etc1, etc2, size, pos, fileSize;
	wav_head		wHead;
	strTagList		tagList[] = {
		{ "INAM", &bgm->title }, { "IART", &bgm->artist }, { "IPRD", &bgm->album },
		{ "ICRD", &bgm->year }, { "ICMT", &bgm->comment }, { "", NULL }
	};
	char	*tagType[] = { "", "ID3v1", "ID3v2.2", "ID3v2.3", "ID3v2.4", "LIST" };

	bgmPropertyClear( bgm, 0 );
	*start = 0;
	*end = sceIoLseek32( fd, 0, SEEK_END );
	fileSize = *end;
	sceIoLseek32( fd, 0, SEEK_SET );
	sceIoRead( fd, head, 12 );
	if (strncmp((char*)head, "RIFF",4) != 0) return -1;			// wavt@Cł͂Ȃ
	if (strncmp((char*)&head[8], "WAVE",4) != 0) return -1;		// wavt@Cł͂Ȃ
	pos = 12;
	bgm->type = 2;												// wavt@C
	while (pos < fileSize) {
		sceIoLseek32( fd, pos, SEEK_SET );
		len = sceIoRead( fd, head, 8 );
		if (len != 8) break;
		pos += 8;
		size = (head[4]) | (head[5]<<8) | (head[6]<<16) | (head[7]<<24);
		if (strncmp((char*)head, "fmt ",4) == 0) {
			len = sceIoRead( fd, wHead.cHeader, 16 );
			if (len == 16) {
				bgm->formatID = wHead.h.formatID;
				bgm->channel = wHead.h.channel;
				bgm->SamplingRate = wHead.h.SamplingRate;
				bgm->avg = wHead.h.avg;
				bgm->blockSize = wHead.h.blockSize;
				bgm->bit = wHead.h.bit;
				if (bgm->formatID != 1) {
					if (bgm->formatID!=0xFFFE || bgm->channel!=2 || bgm->bit<24) {
						bgm->unsupport = 1;						// jAPCMȊOɂ͑ΉĂȂ
					}
				}
			}
		} else if (strncmp((char*)head, "data",4) == 0) {
			*start = pos;										// g`f[^擪
			*end = pos + size;									// g`f[^I
			if (*end > fileSize) {
				bgm->unsupport = 1;								// g`f[^TCYt@CTCY𒴂Ă
			}
		} else if (strncmp((char*)head, "fact",4) == 0 && imgFlag) {
			len = sceIoRead( fd, head, 4 );
			if (len == 4) {
				bgm->samplingLength = (head[0]) | (head[1]<<8) | (head[2]<<16) | (head[3]<<24);
			}
		} else if (strncmp((char*)head, "LIST",4) == 0 && imgFlag) {
			unsigned int	sPos, sSize;
			unsigned char	*utf8;
			char			*buf, atext[256];
			int				i, get;
			sPos = 0;
			sceIoRead( fd, head, 4 );
			sPos += 4;
			if (strncmp((char*)head, "INFO",4) == 0 && bgm->tag==0) {	// ̃^O擾ĂȂȂ
				bgm->tag = 5;									// ID3v2.4͖Ɖ
				while (sPos < size) {
					sceIoLseek32( fd, pos + sPos, SEEK_SET );
					len = sceIoRead( fd, head, 8 );
					if (len != 8) break;						// t@CI[ɒB
					sPos += 8;
					sSize = (head[4]) | (head[5]<<8) | (head[6]<<16) | (head[7]<<24);
					buf = malloc( sSize );
					utf8 = malloc( sSize * 3 );					// ꂭ炢mۂΑvcˁH
					if (buf && utf8) {
						len = sceIoRead( fd, buf, sSize );
						if (len == sSize) {
							Sjis2UTF8Len( utf8, sSize * 3, (u8*)buf, sSize );
							get = 0;
							i = 0;
							while (*tagList[i].name != '\0') {
								if (strncmp((char*)head, tagList[i].name,4) == 0) {
									get = 1;
									if (!*tagList[i].data) {	// Y^O擾ĂȂ
										*tagList[i].data = utf8;
										utf8 = NULL;
									}
									break;
								}
								i++;
							}
							if (!get) {							// gp^O
								sprintf( atext, "%.4s : %.60s\n", head, utf8 );
								if (strlen(bgm->etcTag) + strlen(atext) < 1023) {
									strcat( bgm->etcTag, atext );
								}
							}
						}
					}
					free( utf8 );
					free( buf );
					sSize = (sSize + 1) & ~1;					// oCgɃAC
					sPos += sSize;
				}
			}
		} else if (strncmp((char*)head, "id3 ",4) == 0) {
			getFileID3v2( fd, pos, bgm, &etc1, &etc2, imgFlag );	// ID3v2^O擾
		}
		size = (size + 1) & ~1;									// oCgɃAC
		pos += size;
	}

	//----- ID3v1^O -----

	getFileID3v1( fd, bgm, &etc1, &etc2, imgFlag );				// ID3v1^O擾

	//----- Ȃ̒ -----

	bgm->time = (*end - *start) / (bgm->avg / 100.0f);

	//-----  -----

	if (imgFlag) {
		info = malloc( 256 );
		if (!info) return 0;
		sprintf( info, "FileType : %s\nTagType : %s\nFormatID : %d\nAvg : %d\nBlockSize : %d\n"
		               "Bit : %d\nChannel : %d\nLength : %d\nWaveSize : %d\nTime : %.2f",
		               "wav", tagType[bgm->tag], bgm->formatID, bgm->avg, bgm->blockSize,
		               bgm->bit, bgm->channel, bgm->samplingLength, (*end - *start), bgm->time/100.0f );
		bgm->info = info;
	}
	return 0;
}


//==============================================================
// wavf[^̃fR[h
//--------------------------------------------------------------

//===== wavf[^PCM֕ϊ =====
// pcmSize pcmDataobt@̃TCYiL16bitR16bit𕹂ĂPƃJEgj

static long wavDecodePcm(short *pcmData, long pcmSize, strBgm bgm, char *wavData, long wavSize)
{
	int			pos;
	long		count;
	float		step;
	u8			*s;
	s16			*d, waveL, waveR;

	pos = 0;
	step = 0;
	count = 0;
	waveL = 0;
	waveR = 0;
	s = (u8*)wavData;
	d = pcmData;
	while (pos < wavSize) {
		switch (bgm.bit) {
		case 8:													// 8bit
			if (bgm.channel == 1) {								// m
				waveL = (s[pos] - 128)<<8;
				waveR = waveL;
			} else {											// XeI
				waveL = (s[pos] - 128)<<8;
				waveR = (s[pos+1] - 128)<<8;
			}
			break;
		case 16:												// 16bit
			if (bgm.channel == 1) {								// m
				waveL = (s[pos  ]) | (s[pos+1]<<8);
				waveR = waveL;
			} else {											// XeI
				waveL = (s[pos  ]) | (s[pos+1]<<8);
				waveR = (s[pos+2]) | (s[pos+3]<<8);
			}
			break;
		case 24:												// 24bit
			if (bgm.channel == 1) {								// m
				waveL = (s[pos+1]) | (s[pos+2]<<8);
				waveR = waveL;
			} else {											// XeI
				waveL = (s[pos+1]) | (s[pos+2]<<8);
				waveR = (s[pos+4]) | (s[pos+5]<<8);
			}
			break;
		}
		*d++ = waveL;
		*d++ = waveR;
		count++;
		if (count >= pcmSize) break;							// o̓obt@fullɂȂ
		step += (float)bgm.SamplingRate / 44100;				// ȈՃTvOgϊ
		while (step >= 1) {
			pos += bgm.blockSize;
			step--;
		}
	}
	return count;
}

//===== fR[h =====

static int wavDecode(strAudioInfo *audio, short *playBuf[])
{
	long		size, count;
	SceInt64	ret;
	s16			*d, waveL, waveR;
	u32			time;

	if (gWavInfo.reset) {										// ĐʒuZbg
		gWavInfo.reset = 0;
		gWavInfo.pos = gWavInfo.start;
	}
	filePrefetchSeek( audio->fd, gWavInfo.pos, SEEK_SET );
	size = gWavInfo.readSize;
	if (gWavInfo.pos + size > gWavInfo.end) {					// g`f[^I[
		size = gWavInfo.end - gWavInfo.pos;
	}
	ret = filePrefetchRead( audio->fd, audio->dataBuf, size );
	if (ret < 0) {												// G[
		audio->bytesDecoded = -1;
		return -1;
	}
	if (ret != 0) {
		audio->bytesDecoded = 1;
	} else {
		audio->bytesDecoded = 0;								// ĐI
	}
	if (audio->bgm->unsupport) {
		gWavInfo.pos = 0;										// T|[g
		ret = 1;
		memset( audio->dataBuf, 0, 4 );
	} else {
		gWavInfo.pos += ret;
	}
	if (audio->time > clock()) audio->time = 0;
	if (audio->time) {
		time = (clock() - audio->time) / 1000;
	} else {
		time = 0;
	}
	audio->time = clock();
	if (time) {
		audio->bgm->bitRate = ret * 8 / time;					// rbg[ǧvZ
	} else {
		audio->bgm->bitRate = 0;
	}

	count = wavDecodePcm( playBuf[audio->swap], WAVE_DECODE_STEP, *audio->bgm, audio->dataBuf, ret );
	d = &playBuf[audio->swap][(count - 1) * 2];
	waveL = *d++;
	waveR = *d++;
	while (count < WAVE_DECODE_STEP) {							// \萔ɑȂ⊮
		*d++ = waveL;
		*d++ = waveR;
		count++;
	}
	audio->outBuf = playBuf[audio->swap];
	audio->swap = 1 - audio->swap;
	return 0;
}

//===== ݒ =====

static int wavSetup(char *path, strAudioInfo *audio, strBgm *bgm)
{
	int				ret;
	long			start, end;

	audio->fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
	if (audio->fd < 0) {
		return -1;
	}
	ret = getWavFileTag( audio->fd, bgm, &start, &end, 1 );		// waṽ^O擾
	sceIoClose( audio->fd );
	if (ret) {													// tH[}bgG[
		bgmPropertyClear( bgm, 0 );
		bgm->unsupport = 1;
		return -2;
	}

	//--- wav̏ݒ ---

	gWavInfo.start = start;
	gWavInfo.end = end;
	gWavInfo.pos = start;
	gWavInfo.readSize = 1152 * (float)bgm->SamplingRate / 44100.0f * bgm->blockSize;
	gWavInfo.reset = 0;

	audio->fd = filePrefetchOpen( path );
	if (audio->fd < 0) return -3;
	audio->type = 1;											// wav`
	audio->bgm = bgm;
	audio->swap = 0;
	audio->bytesDecoded = 0;
	audio->exit = 0;
	audio->full_semaid = sceKernelCreateSema( "full_sema", 0, 0, 1, 0 );
	audio->empty_semaid = sceKernelCreateSema( "empty_sema", 0, 1, 1, 0 );
	sceKernelStartThread( gDecodeThread, sizeof(strAudioInfo**), &audio );
	sceKernelWaitSema( audio->full_semaid, 1, NULL );
	sceKernelSignalSema( audio->full_semaid, 0 );
	sceKernelSignalSema( audio->empty_semaid, 1 );
	return 0;
}

//===== ĐI =====

static void wavPlayend(strAudioInfo *audio)
{
	
}

//===== ĐʒuZbg =====

static void wavReset(strAudioInfo *audio)
{
	gWavInfo.reset = 1;
}





//==============================================================
// t@C̃fR[h
//--------------------------------------------------------------

static int audioDecodeThread(SceSize args, void *argp)
{
	strAudioInfo	*audio = *(strAudioInfo**)argp;
	short			*playBuf[2];
	int				ret;

	playBuf[0] = memalign( 64, sizeof(short) * PCM_BUF_SIZE );
	playBuf[1] = memalign( 64, sizeof(short) * PCM_BUF_SIZE );
	if (playBuf[0] == NULL || playBuf[1] == NULL) {
		free( playBuf[1] );
		free( playBuf[0] );
		sceKernelExitThread( 0 );
		return 0;
	}

	while (!audio->exit) {
		sceKernelWaitSema( audio->empty_semaid, 1, NULL );
		sceKernelSignalSema( audio->empty_semaid, 0 );
		switch (audio->type) {
		case 0:
			ret = mp3Decode( audio, playBuf );
			break;
		case 1:
			ret = wavDecode( audio, playBuf );
			break;
		}
		if (ret) break;
		sceKernelSignalSema( audio->full_semaid, 1 );
	}

	free( playBuf[1] );
	free( playBuf[0] );
	audio->exit = 0;
	sceKernelExitThread( 0 );
	return 0;
}


//==============================================================
// TutH_܂߂Ď̉t@CT
//--------------------------------------------------------------
// subDirFlagFTutH_T邩
//   0    Ȃ
//   ȊO 
// revFlagF   T
//   0    
//   ȊO t
//--------------------------------------------------------------

static void audioPlaySearch(char *playDir, int *next, char *play_1st, char *play_next, int subDirFlag, int revFlag)
{
	strAudioInfo	*audio = &gAudioInfo;
	SceUID			dfd;
	SceIoDirent		dir;
	char			*p, path[FILE_PATH];

	dfd = sceIoDopen( playDir );
	if (dfd < 0) return;
	memset( &dir, 0, sizeof(dir) );
	while (sceIoDread(dfd, &dir) > 0) {
		if (strcmp(dir.d_name, ".") == 0) continue;
		if (strcmp(dir.d_name, "..") == 0) continue;
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNg̏ꍇ
			if (subDirFlag) {									// TufBNgTȂ
				strcpy( path, playDir );
				strcat( path, "/" );
				strcat( path, dir.d_name );
				audioPlaySearch( path, next, play_1st, play_next, 1, revFlag );
				if (*next == 2) break;							// TufBNgŎ̃t@C
			}
		} else {												// t@C̏ꍇ
			p = strrchr( dir.d_name, '.' );
			if (p) {
				if (stricmp(p,".mp3")==0 || stricmp(p,".wav")==0) {
					if (revFlag) {								// tT
						if (strcmp(dir.d_name, audio->playName) == 0) {
							if (play_next[0]) {					// Õt@C擾ĂȂ
								*next = 2; 						// 
								break;
							}
						}
						strcpy( play_next, dir.d_name );
						strcpy( play_1st, dir.d_name );
						strcpy( audio->playDir, playDir );
					} else {									// T
						if (!play_1st[0]) {
							strcpy( play_1st, dir.d_name );
							strcpy( audio->playDir, playDir );	// 肠ŏɌt@C̃fBNgʒuɃZbg
						}
						if (*next) {
							*next = 2; 							// 
							strcpy( play_next, dir.d_name );
							strcpy( audio->playDir, playDir );	// Ώۃt@C̃fBNgʒuZbg
							break;
						}
						if (strcmp(dir.d_name, audio->playName) == 0) {
							*next = 1; 							// ̌₪Ώ
						}
					}
				}
			}
		}
	}
	sceIoDclose( dfd );
}

//===== ̉t@C =====

static int audioPlayEnd(void)
{
	strAudioInfo	*audio = &gAudioInfo;
	int				next = 0, revFlag = 0;
	char			play_1st[FILE_PATH] = {0}, play_next[FILE_PATH] = {0};

	if (audio->running < 3) {
		return -1;												// ĐȂ玟̋ȂɍsȂ
	}
	if (audio->running == 4) {									// ̋
		revFlag = 0;
	} else if (audio->running == 5) {							// Ő
		revFlag = 1;
	}

	switch (s2ch.cfg.bgmLoop) {
	case 0:														// [vȂ
		if (audio->running>=4 && audio->running<=5) {
			audioPlaySearch( audio->startDir, &next, play_1st, play_next, 1, revFlag );
		} else {
			audio->running = 1;
			return -1;											// tI
		}
		break;
	case 1:														// Pȃ[v
		if (audio->running>=4 && audio->running<=5) {
			audioPlaySearch( audio->startDir, &next, play_1st, play_next, 1, revFlag );
		} else {
			audio->running = 0;
			return 0;
		}
		break;
	case 2:														// tH_Ŏ̋
		audioPlaySearch( audio->startDir, &next, play_1st, play_next, 0, revFlag );
		break;
	case 3:														// TutH_܂ݎ̋
		audioPlaySearch( audio->startDir, &next, play_1st, play_next, 1, revFlag );
		break;
	case 4:														// wtH_ȉŎ̋
		audioPlaySearch( s2ch.cfg.bgmDir, &next, play_1st, play_next, 1, revFlag );
		break;
	}

	if (next == 2) {											// ̋Ȃ
		strcpy( audio->playName, play_next );
	} else {													// Ȃ̂ōŏɌ
		strcpy( audio->playName, play_1st );
	}
	audio->running = 0;
	return 0;
}


//==============================================================
// BGMĐXbh
//--------------------------------------------------------------

static int audioPlayThread(SceSize args, void *argp)
{
	int				lastDecoded = 0;
	int				volume = PSP_AUDIO_VOLUME_MAX;
	int				channel = -1;
	int				ret, type;
	char			path[FILE_PATH];
	SceUInt			timeout;
	strAudioInfo	*audio = *(strAudioInfo**)argp;
	int				(*setup[2])(char *path, strAudioInfo *audio, strBgm *bgm) = { mp3Setup, wavSetup };
	void			(*playend[2])(strAudioInfo *audio) = { mp3Playend, wavPlayend };
	void			(*reset[2])(strAudioInfo *audio) = { mp3Reset, wavReset };

	audio->dataBuf = memalign( 64, sizeof(char) * (MP3_BUF_SIZE) );
	audio->pcmBuf = memalign( 64, sizeof(short) * PCM_BUF_SIZE );
	if (audio->dataBuf == NULL || audio->pcmBuf == NULL) {
		free( audio->dataBuf );
		free( audio->pcmBuf );
		sceKernelExitThread( 0 );
		return -1;
	}

	do {

		//--- t@CI[v ---

		strcpy( path, audio->playDir );
		strcat( path, "/" );
		strcat( path, audio->playName );
		strcpy( s2ch.bgmFile, path );
		strcpy( audio->lastSDir, audio->startDir );
		strcpy( audio->lastDir, audio->playDir );
		strcpy( audio->lastName, audio->playName );
		switch (checkExt(audio->playName)) {
		case EXT_TYPE_MP3:
			type = 0;
			break;
		case EXT_TYPE_WAVE:
			type = 1;
			break;
		default:
			type = 0;
			break;
		}
		gBGM.bgmID++;											// BGMɕω
		audio->time = 0;
		ret = setup[type]( path, audio, &gBGM );

		//--- Đ ---

		while (ret == 0) {
			if (audio->running) {
				if (audio->running == 6) {
					reset[type]( audio );						// ĐʒuZbg
					gBGM.pos = 0;
					audio->running = 0;
					sceKernelDelayThread(1000);
					continue;
				}
				if (audio->running == 2) {						// ꎞ~
					sceKernelSleepThread();
					continue;
				}
				break;
			}
			timeout = AUDIO_TIMEOUT;
			if (sceKernelWaitSema(audio->full_semaid, 1, &timeout) < 0) { // ǂݍ
				gBGM.pos = 0;
				audio->running = 1;
				break;
			}
			sceKernelSignalSema( audio->full_semaid, 0 );
			if (audio->bytesDecoded <= 0) {						// fR[hG[fR[hI
				if (audio->bytesDecoded == 0 || audio->bytesDecoded == (int)FILE_END) {	// file end
					reset[type]( audio );						// ĐʒuZbg
					gBGM.pos = 0;
					audio->running = 3;
				}
				break;
			} else {
				if (channel < 0 || lastDecoded != audio->bytesDecoded) {
					if (channel >= 0) {
						sceAudioChRelease( channel );
					}
					channel = sceAudioChReserve( PSP_AUDIO_NEXT_CHANNEL, 1152, PSP_AUDIO_FORMAT_STEREO );
				}
				lastDecoded = audio->bytesDecoded;
				while (sceAudioGetChannelRestLength(channel)) {
					sceKernelDelayThread(1000);
				}
				gBGM.pos += sceAudioOutput( channel, volume, audio->outBuf );
				if (gBGM.unsupport) gBGM.pos = 0;				// T|[g
				sceKernelSignalSema( audio->empty_semaid, 1 );
			}
		}

		//--- I ---

		if (channel >= 0) {
			sceAudioChRelease( channel );
			channel = -1;
		}
		audio->exit = 1;										// fR[hXbhIv
		sceKernelSignalSema( audio->empty_semaid, 1 );
		sceKernelDelayThread(100);
		sceKernelWaitThreadEnd( gDecodeThread, NULL );			// fR[hXbhI܂őҋ@
		playend[type]( audio );
		sceKernelDeleteSema( audio->full_semaid );
		sceKernelDeleteSema( audio->empty_semaid );
		filePrefetchClose( audio->fd );
		bgmPropertyClear( &gBGM, 0 );
	} while (audioPlayEnd() == 0);

	gBGM.bgmID++;												// BGMɕω
	free( audio->pcmBuf );
	free( audio->dataBuf );
	audio->playDir[0] = '\0';
	audio->playName[0] = '\0';
	s2ch.bgmFile[0] = '\0';
	sceKernelExitThread( 0 );
	return 0;
}

//==============================================================
// ݒ
//--------------------------------------------------------------


int audioInit(iniList *ini)
{
	char		msg[256];

	s2ch.bgmFile[0] = '\0';
	bgmPropertyClear( &gBGM, 1 );

	strcpy( msg, "AV module (" );
	if (sceUtilityLoadModule(PSP_MODULE_AV_AVCODEC) < 0) {
		strcat( msg, "AV_AVCODEC" );
	}
	if (sceUtilityLoadModule(PSP_MODULE_AV_MP3) < 0) {
		if (strlen(msg)!=11) strcat( msg, "," );
		strcat( msg, "AV_MP3" );
	}
	if (strlen(msg) != 11) {
		strcat( msg,") load error" );
		strcpy( ini->msg[ini->phase], msg );
	}
	gPlayThread = sceKernelCreateThread( "BGM_play_thread", (SceKernelThreadEntry)&audioPlayThread, 0x1F, 0x4000, 0, NULL );
	if (gPlayThread < 0) {
		ini->error = -1;
		return -1;
	}
	gDecodeThread = sceKernelCreateThread( "audio_decode_thread", (SceKernelThreadEntry)&audioDecodeThread, 0x1F, 0x0800, 0, NULL );
	if (gDecodeThread < 0) {
		ini->error = -1;
		return -1;
	}
	memset( &gAudioInfo, 0, sizeof(strAudioInfo) );
	gAudioInfo.running = 1;
	gAudioInfo.outBuf = NULL;
	gAudioInfo.dataBuf = NULL;
	gAudioInfo.pcmBuf = NULL;
	return 0;
}


//==============================================================
// Đ/ꎞ~
//--------------------------------------------------------------
// w肳ꂽt@CĐB
// pathnullw肳ꂽꍇ͈ꎞ~/Đ
//--------------------------------------------------------------

int audioPlay(const char *path, const char *name)
{
	strAudioInfo	*audio = &gAudioInfo;

	//----- t@Cw肳ĂȂ -----

	if (path==NULL || name==NULL) {
		switch (audio->running) {
		case 0:													// ĐȂꎞ~
			audio->running = 2;
			return 0;
			break;
		case 1:													// ~ȂBGMtH_Đ
			break;
		case 2:													// ꎞ~ȂĊJ
			audio->running = 0;
			sceKernelWakeupThread( gPlayThread );
			return 0;
			break;
		case 3:													// ̋Ȃֈڍs̏ꍇ͉Ȃ
			return 0;
			break;
		}
	}

	//----- t@Cw肳Ă -----

	if (audio->running == 0) {									// ĐȂ~
		audioStop();
	}

	if (audio->running == 1) {									// Đ
		if (path == NULL) {										// t@Cw肳ĂȂ̂
			if (audio->lastDir[0] == '\0') {					// ܂ĐĂȂ
				strcpy( audio->startDir, s2ch.cfg.bgmDir );		// BGMtH_
				strcpy( audio->playDir, s2ch.cfg.bgmDir );
				audio->playName[0] = '\0';
				audio->running = 4;
				audioPlayEnd();									// Đt@C
			} else {											// OĐt@C
				strcpy( audio->startDir, audio->lastSDir );
				strcpy( audio->playDir, audio->lastDir );
				strcpy( audio->playName, audio->lastName );
			}
		} else {												// w肳ꂽt@CʒuZbg
			strcpy( audio->startDir, path );
			strcpy( audio->playDir, path );
			strcpy( audio->playName, name );
		}
	}
	audio->running = 0;
	sceKernelStartThread( gPlayThread, sizeof(strAudioInfo**), &audio );
	return 0;
}


//==============================================================
// Đ~
//--------------------------------------------------------------

void audioStop(void)
{
	strAudioInfo	*audio = &gAudioInfo;
	int			temp = audio->running;

	if (audio->running != 1) {
		audio->running = 1;
    	if (temp == 2) {
    		sceKernelWakeupThread( gPlayThread );
    	}
    	sceKernelWaitThreadEnd( gPlayThread, NULL );
	}
	audio->playDir[0] = '\0';
	audio->playName[0] = '\0';
	s2ch.bgmFile[0] = '\0';
	bgmPropertyClear( &gBGM, 0 );
}


//==============================================================
// ̋
//--------------------------------------------------------------

void audioNext(void)
{
	strAudioInfo	*audio = &gAudioInfo;

	if (audio->running == 1) {									// ~Ȃ
		if (audio->lastDir[0] == '\0') {						// ܂ĐĂȂ
			strcpy( audio->startDir, s2ch.cfg.bgmDir );			// BGMtH_
			strcpy( audio->playDir, s2ch.cfg.bgmDir );
			audio->playName[0] = '\0';
		} else {												// OĐt@C
			strcpy( audio->startDir, audio->lastSDir );
			strcpy( audio->playDir, audio->lastDir );
			strcpy( audio->playName, audio->lastName );
		}
		audio->running = 4;
		audioPlayEnd();											// Đt@C
		audio->running = 0;
		sceKernelStartThread( gPlayThread, sizeof(strAudioInfo**), &audio );
		return;

	} else if (audio->running == 2) {							// ꎞ~Ȃ
		audio->running = 1;
		sceKernelWakeupThread( gPlayThread );
	}

	audio->running = 4;											// ̋Ȃ
}


//==============================================================
// Ő
//--------------------------------------------------------------

void audioBack(void)
{
	strAudioInfo	*audio = &gAudioInfo;

	if (audio->running == 1) {									// ~Ȃ
		if (audio->lastDir[0] == '\0') {						// ܂ĐĂȂ
			strcpy( audio->startDir, s2ch.cfg.bgmDir );			// BGMtH_
			strcpy( audio->playDir, s2ch.cfg.bgmDir );
			audio->playName[0] = '\0';
		} else {												// OĐt@C
			strcpy( audio->startDir, audio->lastSDir );
			strcpy( audio->playDir, audio->lastDir );
			strcpy( audio->playName, audio->lastName );
		}
		audio->running = 5;
		audioPlayEnd();											// Đt@C
		audio->running = 0;
		sceKernelStartThread( gPlayThread, sizeof(strAudioInfo**), &audio );
		return;

	} else if (audio->running == 2) {							// ꎞ~
		audio->running = 1;
		sceKernelWakeupThread( gPlayThread );
	}

	audio->running = 5;											// ŐȂ
}


//==============================================================
// ŏĐ
//--------------------------------------------------------------

void audioReplay(void)
{
	strAudioInfo	*audio = &gAudioInfo;

	if (audio->running == 1) {									// ~Ȃ
		audioPlay( NULL, NULL );
		return;

	} else if (audio->running == 2) {							// ꎞ~Ȃ
		audio->running = 6;
		sceKernelWakeupThread( gPlayThread );
	}

	audio->running = 6;											// Ȃ̎n߂
}


//==============================================================
// Đ󋵂̎擾
//--------------------------------------------------------------
// ߂lF0 Đ
//         1 ~
//         2 ꎞ~
//         3 ̋Ȃֈڍs
//--------------------------------------------------------------

int audioGetPlayMode(void)
{
	strAudioInfo	*audio = &gAudioInfo;

	return (audio->running);
}


//==============================================================
// I
//--------------------------------------------------------------

void audioTerm(void)
{
	strAudioInfo	*audio = &gAudioInfo;

	if (audio->running != 1) {
		audioStop();
	}
	if (gDecodeThread > 0) {
		sceKernelDeleteThread( gDecodeThread );
	}
	if (gPlayThread > 0) {
		sceKernelDeleteThread( gPlayThread );
	}
	sceUtilityUnloadModule( PSP_MODULE_AV_AVCODEC );
	sceUtilityUnloadModule( PSP_MODULE_AV_MP3 );
	bgmPropertyClear( &gBGM, 0 );
}


//==============================================================
// ID3^O摜ʕ
//--------------------------------------------------------------

char *getID3ApicType(int picType)
{
	char	*type[] = {
		"Other",
		"32x32 pixels 'file icon'",
		"Other file icon",
		"Cover (front)",
		"Cover (back)",
		"Leaflet page",
		"Media",
		"Lead artist/lead performer/soloist",
		"Artist/performer",
		"Conductor",
		"Band/Orchestra",
		"Composer",
		"Lyricist/text writer",
		"Recording Location",
		"During recording",
		"During performance",
		"Movie/video screen capture",
		"A bright coloured fish",
		"Illustration",
		"Band/artist logotype",
		"Publisher/Studio logotype",
	};

	if (picType<0 || picType>20) picType = 0;
	return type[picType];
}

//==============================================================
// BGMߍ݉摜f[^̎擾
//--------------------------------------------------------------
// bgmFileFBGMt@C
// inPathF Ώۉ摜̃t@Ci"xxx - 1"̗l'- '̌ɉ摜ԍw肷j
// bgmF    bgmǗ\́iĂяoŒ`Ăj
//--------------------------------------------------------------
// ANZXID3^ObgmɎ荞݁AȌbgm̂ݎQƂB
//--------------------------------------------------------------

strBgmPic *getBgmApicData(char *bgmFile, char *inPath, strBgm *bgm, char *info)
{
	char		*p;
	long		start, end;										// mpegt[̊Jn/Iʒuigpj
	int			pos, count;
	SceUID		fd;
	strBgmPic	*pic;

	if (!bgm->pic) {
		fd = sceIoOpen( bgmFile, PSP_O_RDONLY, FILE_PARMISSION );
		if (fd < 0) {
			sprintf( info, "%sJ܂", bgmFile );
			return NULL;
		}
		switch (checkExt(bgmFile)) {
		case EXT_TYPE_MP3:
			getMP3FileTag( fd, bgm, &start, &end, 1 );
			break;
		case EXT_TYPE_WAVE:
			getWavFileTag( fd, bgm, &start, &end, 1 );
			break;
		}
		sceIoClose( fd );
	}
	if (bgm->picCount == 0) {									// ߍ݉摜
		sprintf( info, "%sɃA[g[N܂", bgmFile );
		return NULL;
	}
	pic = bgm->pic;
	p = strrchr( inPath, '-' );
	if (p) {
		pos = atoi( p+1 ) - 1;									// ^[Qbg̈ʒu
	} else {
		pos = 0;
	}
	count = 0;
	while (pic && count < pos) {								// w肳ꂽߍ݉摜f[^փ|C^ړ
		if (!pic->next) break;
		pic = pic->next;
		count++;
	}
	if (!pic) {
		sprintf( info, "%sɎw肳ꂽA[g[N܂", bgmFile );
	}
	return pic;
}


//==============================================================
// wavt@CPCMf[^荞
//--------------------------------------------------------------
// ߂lF 0 I
//         -1 t@CANZXG[
//         -2 mۂɎss
//         -3 tH[}bgG[
//--------------------------------------------------------------
// w肳ꂽwavt@C̔g`f[^44100Hz,16bit,XeIɃfR[hĕԂ܂B
// G[ꍇpcmDataɂNULLԂ܂B
//--------------------------------------------------------------

int wavFileDecode(char *path, u32 **pcmData, u32 *pcmSize)
{
	char			*wavData;
	int				ret;
	long			pos, pcmPos, start, end, size, count;
	u32				*buf;
	strBgm			bgm;
	SceUID			fd;

	*pcmData = NULL;
	*pcmSize = 0;
	wavData = malloc( PCM_BUF_SIZE );							// Ɨp
	if (!wavData) {
		return -2;												// mۂɎss
	}

	bgmPropertyClear( &bgm, 1 );
	fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
	if (fd < 0) {
		free( wavData );
		return -1;
	}
	ret = getWavFileTag( fd, &bgm, &start, &end, 0 );			// waṽ^O擾
	if (ret) {													// tH[}bgG[
		ret = -3;
		goto wavFileDecodeExit;
	}
	count = 44100.0f / bgm.SamplingRate * 4 * (end - start) / bgm.blockSize;
	*pcmSize = count / sizeof(u32);
	buf = malloc( count );										// WJPCMf[^p
	*pcmData = buf;
	if (!buf) {													// mۂɎss
		ret = -2;
		goto wavFileDecodeExit;
	}

	ret = 0;
	pos = start;
	sceIoLseek32( fd, pos, SEEK_SET );
	pcmPos = 0;
	while (pos < end) {
		size = PCM_BUF_SIZE;
		if (size > end - pos) size = end - pos;
		size = sceIoRead( fd, wavData, size );
		if (size < 0) {											// t@CANZXG[
			ret = -1;
			free( buf );
			*pcmData = NULL;
			break;
		}
		pos += size;
		size = wavDecodePcm( (short*)buf, count, bgm, wavData, size );
		buf += size;
		count -= size * sizeof(u32);
	}

wavFileDecodeExit:
	sceIoClose( fd );
	bgmPropertyClear( &bgm, 0 );
	free( wavData );
	return ret;
}
