//==============================================================
// freeze viewer   (STPP.06)
//     for PSP CFW5.00 M33-6
//--------------------------------------------------------------
// ֘A
//--------------------------------------------------------------

#include <stdio.h>
#include <string.h>
#include <malloc.h>
#include <psputils.h>
#include <pspdisplay.h>
#include <pspgu.h>
#include "FreezeViewer.h"
#include "fvDraw.h"
#include "intraFont.h"
#include "charConv.h"

typedef struct {
	unsigned short	u, v;
	short			x, y, z;
} Vertex;

typedef struct {
	short	x;
	short	y;
	short	z;
} Vertex3;


//==============================================================
// ẅ̃Rs[
//--------------------------------------------------------------
// ʏ̎w肳ꂽ̈imageɎ荞ށB
// image͗\ߕKvȑ傫 DrawImgCreate() ŊmۂĂĂB
//--------------------------------------------------------------

void BoxCopy2(DrawImg *image, int x, int y)
{
	Color	*cor, *dVram = getVramDrawBuffer();
	int		i, j, stepD, stepS, wx, wy;

	if (image) {
		sceKernelDcacheWritebackInvalidateAll();				// LbṼCgobN
		wx = image->wx;
		wy = image->wy;
		cor = (Color*)image->data;
		dVram += y * PSP_LINE_SIZE + x;
		stepD = image->width - wx;
		stepS = PSP_LINE_SIZE - wx;
		for (i = 0; i < wy; i++, cor += stepD, dVram += stepS) {
			for (j = 0; j < wx; j++, cor++, dVram++) {
				*cor = (*dVram) | 0xFF000000;
			}
		}
		image->wx = wx;
		image->wy = wy;
	}
}

//==============================================================
// ʃC[WVRAMɑޔ
//--------------------------------------------------------------
// screen : 0 \
//          1 
//--------------------------------------------------------------
// ݂̉ʑŜVRAMɑҔB
//--------------------------------------------------------------

void ScreenCopy2(int screen)
{
	Color	*dVram;

	if (screen) {
		dVram = getVramDrawBuffer();
	} else {
		dVram = getVramDisplayBuffer();
	}

	sceKernelDcacheWritebackInvalidateAll();
	guStart();
	sceGuCopyImage( GU_PSM_8888, 0, 0, 480, 272, 512, dVram, 0, 272*2.5, 512, VRAM );
	sceGuFinish();
	sceGuSync( GU_SYNC_FINISH, GU_SYNC_WHAT_DONE );
}

void ScreenCopy3(int screen)
{
	Color	*dVram;

	if (screen) {
		dVram = getVramDrawBuffer();
	} else {
		dVram = getVramDisplayBuffer();
	}

	sceKernelDcacheWritebackInvalidateAll();
	sceGuCopyImage( GU_PSM_8888, 0, 0, 480, 272, 512, dVram, 0, 272*2.5, 512, VRAM );
}

//==============================================================
// ʃC[WVRAM畜A
//--------------------------------------------------------------
// ݂̉ʑŜVRAM畜AB
//--------------------------------------------------------------

void ScreenPaste2(void)
{
	Color	*dVram = getVramDrawBuffer();

	guStart();
	sceGuCopyImage( GU_PSM_8888, 0, 272*2.5, 480, 272, 512, VRAM, 0, 0, 512, dVram );
	sceGuFinish();
	sceGuSync( GU_SYNC_FINISH, GU_SYNC_WHAT_DONE );
}

void ScreenPaste3(void)
{
	Color	*dVram = getVramDrawBuffer();

	sceGuCopyImage( GU_PSM_8888, 0, 272*2.5, 480, 272, 512, VRAM, 0, 0, 512, dVram );
}

//==============================================================
// ʃC[W荞
//--------------------------------------------------------------
// dispFΏVRAM (0:DisplayBuffer ȊO:DrawBuffer)
//--------------------------------------------------------------
// \ʒ̎ẅ荞ށB
// 荞񂾃C[W̕\ blitImageToScreen() ŁB
// Ŏ荞񂾃C[W DrawPicAlpha() ł͕\łȂB
//--------------------------------------------------------------

void blitScreenToImage(int disp, int sx, int sy, int width, int height, DrawImg* destination, int dx, int dy)
{
	Color	*vram;

	if (disp) {
		vram = getVramDrawBuffer();
	} else {
		vram = getVramDisplayBuffer();
	}
	sceKernelDcacheWritebackInvalidateAll();
	guStart();
	sceGuCopyImage( GU_PSM_8888, sx, sy, width, height, PSP_LINE_SIZE, vram, dx, dy, destination->width, destination->data );
	sceGuFinish();
	sceGuSync( GU_SYNC_FINISH, GU_SYNC_WHAT_DONE );
}

//==============================================================
// C[W̎ẅhԂ
//--------------------------------------------------------------

void BoxFillImage(DrawImg *image, int x,int y, int wx, int wy, Color cor)
{
	Color	*p;
	int		i, j, stepD;

	if (x < 0 || y < 0) return;
	if (x > image->width || y > image->height) return;			// n_C[WO
	if (x+wx > image->width) wx = image->width - x;
	if (y+wy > image->height) wy = image->height - y;			// ẅ̕␳

	p = (Color*)image->data + y * image->width + x;
	stepD = image->width - wx;
	for (i = 0; i < wy; i++, p+=stepD) {
		for (j = 0; j < wx; j++, p++) {
			*p = cor;
		}
	}
	sceKernelDcacheWritebackInvalidateAll();
}

//==============================================================
// cXN[o[̍쐬
//--------------------------------------------------------------
// image     F쐬eNX`[i[
// max       Fڐ
// windowSizeFxɉʂɕ\ł鍀ڐ
// barSize   FXN[o[YőTCY
// cor       FXN[o[̊{F
//--------------------------------------------------------------
// XN[o[̃eNX`[쐬B
// eNX`[YTCY̓XN[o[YTCYɐݒ肳܂B
//--------------------------------------------------------------

void MakeRollBar(DrawImg *image, int max, int windowSize, int barSize, Color cor)
{
	const u8	barPtn[4][8] = {								// XN[o[̌`
		{ 0x00, 0x00, 0xA0, 0xA0, 0xA0, 0xA0, 0x00, 0x00 },
		{ 0x00, 0xD0, 0xA0, 0xA0, 0x80, 0x80, 0x80, 0x00 },
		{ 0xFF, 0xD0, 0xA0, 0x80, 0x80, 0x60, 0x40, 0x80 },
		{ 0xFF, 0xD0, 0xA0, 0x80, 0x80, 0x60, 0x40, 0x80 } };
	Color	*p;
	int		i, j, stepD, size;

	if (max == 0) {
		size = 0;
	} else if (max < 1) {
		size = barSize;
	} else {
		size = barSize / max;
	}
	if (size > image->height) size = image->height;				// eNX`[TCY𒴂Ȃ␳
	if (size < 8) size = 8;										// ŏTCY

	if (max == 0) {
		image->wy = 0;

	} else {
		image->wy = size;										// XN[o[̃TCY
		size -= 6;												// ㉺̌`Xy[X
		p = (Color*)image->data;
		stepD = image->width - image->wx;
		for (i = 0; i < 3; i++, p += stepD) {					// [
			for (j = 0; j < 8; j++, p++) {
				*p = ((Color)barPtn[i][j] << 24) + cor;
			}
		}
		for (i = 0; i < size; i++, p += stepD) {				// 
			for (j = 0; j < 8; j++, p++) {
				*p = ((Color)barPtn[3][j] << 24) + cor;
			}
		}
		for (i = 0; i < 3; i++, p += stepD) {					// [
			for (j = 0; j < 8; j++, p++) {
				*p = ((Color)barPtn[2 - i][j] << 24) + cor;
			}
		}
	}

	BoxFillImage( image, 0, image->wy, image->width, image->height - image->wy, 0 );	// ]NA
}

//==============================================================
// cXN[o[̕\
//--------------------------------------------------------------
// image     FMakeRollBar()ō쐬eNX`[
// x         FXN[o[̊W
// y         FXN[o[̊W
// pos       F݈ʒu
// max       Fڐ
// windowSizeFxɉʂɕ\ł鍀ڐ
// barSize   FXN[o[YőTCY
//--------------------------------------------------------------
// MakeRollBar()ō쐬XN[o[\܂B
//--------------------------------------------------------------

void DrawRollBar(DrawImg *image, int x, int y, float pos, int max, int windowSize, int barSize)
{
	int		ypos;

	if (max <= 1) {
		ypos = 0;
	} else {
		ypos = (float)(barSize - image->wy) / (max - 1) * pos;
		if (ypos + image->wy > barSize) ypos = barSize - image->wy - 1;
	}
	DrawPicAlpha( x, y + ypos, image, 0.75f, 1.0f );
}

//==============================================================
// intraFont̕\iUTF8j
//--------------------------------------------------------------
// x,y  :\Jnʒu
// str  :\(UTF8)
// size :tHgTCY
// fCor :tHg̐F
// cCor :e̐F(0:eȂ)
// alpha:ߌW(0.0:`1.0:߂Ȃ)
//--------------------------------------------------------------

int if_print(int x, int y, char *str, float size, Color fCor, Color cCor, float alpha)
{
	int		x2;
	Color	alp;

	if (alpha>1.0f) alpha = 1.0f;
	alp = (Color)(0xFF * alpha) << 24;

	if (cCor) {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp, (cCor & 0x00FFFFFF) | alp, INTRAFONT_CACHE_ALL );
	} else {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp, 0, INTRAFONT_CACHE_ALL );
	}
	x2 = intraFontPrint( gJpn0, x, y, str );

	return x2;
}

//==============================================================
// intraFont̕\iVtgJISj
//--------------------------------------------------------------
// x,y  :\Jnʒu
// str  :\(UTF8)
// size :tHgTCY
// fCor :tHg̐F
// cCor :e̐F(0:eȂ)
// alpha:ߌW(0.0:`1.0:߂Ȃ)
//--------------------------------------------------------------

int if_printSjis(int x, int y,char *str, float size, Color fCor, Color cCor, float alpha)
{
	int		x2;
	char	utf8[512];
	Color	alp;

	if (alpha>1.0f) alpha = 1.0f;
	alp = (Color)(0xFF * alpha) << 24;

	if (cCor) {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp,(cCor & 0x00FFFFFF) | alp, INTRAFONT_CACHE_ALL );
	} else {													// e
		intraFontSetStyle( gJpn0, size, (fCor & 0x00FFFFFF) | alp, 0, INTRAFONT_CACHE_ALL );
	}
	psp2chSjis2UTF8( utf8, str );
	x2 = intraFontPrint( gJpn0, x, y, utf8 );

	return x2;
}

//==============================================================
// w肳ꂽŕ؂
//--------------------------------------------------------------
// dst  :o͕iUTF8j
// str  :ɂȂ镶iUTF8j
// width:ڕW̕idotj
// size :tHgTCY
//--------------------------------------------------------------
// strwidthŎw肳ꂽhbgɎ܂悤dstɃRs[B
// strrŐ؂ꍇdst̖ɁucvǉB
//--------------------------------------------------------------

void if_clipText(char *dst, char *str, int width, float size)
{
	char	c[4] = {0,0,0,0};
	float	w, xSize;

	*dst = '\0';
	intraFontSetStyle( gJpn0, size, 0, 0, 0 );
	xSize = intraFontMeasureText( gJpn0, "..." );
	while (*str) {												// 1Â𒲂ׂ
		if ((unsigned char)*str <= 0x7F) {						// 1oCgR[hiASCIIj
			c[0] = *(str++);
			c[1] = '\0';
		} else if ((unsigned char)*str <= 0xDFU) {				// 2oCgR[h
			c[0] = *(str++);
			c[1] = *(str++);
			c[2] = '\0';
		} else if ((unsigned char)*str <= 0xEFU) {				// 3oCgR[h
			c[0] = *(str++);
			c[1] = *(str++);
			c[2] = *(str++);
			c[3] = '\0';
		} else {
			str++;
			c[0] = '\0';
		}
		w = intraFontMeasureText( gJpn0, c );
		if (xSize+w > width) {
			strcpy( dst, "..." );
			dst += 3;
			break;
		}
		xSize += w;
		*(dst++) = c[0];
		if (c[1]) {
			*(dst++) = c[1];
			if (c[2]) {
				*(dst++) = c[2];
			}
		}
	}
	*dst = '\0';
}

//==============================================================
// {wt̉摜̓ߕ\
//--------------------------------------------------------------

static int NextPower2(int x)
{
	int		n;

	n = 1;
	while (n < x && n) n <<= 1;
	return n;
}

#define SLICE_SIZE 64
static void DrawPicAlphaMain(int x, int y, DrawImg *image, Color *p, int sw, int sh, float alpha, float scale)
{
	Vertex*	vertices;
	int		i;
	int		dy;

	if (alpha > 1.0f) alpha = 1.0f;

	sceGuDisable( GU_DEPTH_TEST );
	sceGuTexMode( GU_PSM_8888, 0, 0, GU_FALSE );
	sceGuTexFunc( GU_TFX_MODULATE, GU_TCC_RGBA );
	sceGuTexFilter( GU_LINEAR, GU_LINEAR );
	sceGuColor( GU_RGBA(0xFF, 0xFF, 0xFF, (int)(alpha * 255.0f)) );

	dy = 32 * scale;
	sceGuTexImage( 0, NextPower2(image->width), NextPower2(image->height), image->width, p );
	for (i = 0; (i + SLICE_SIZE) < sw; i += SLICE_SIZE) {
		vertices = (Vertex*)sceGuGetMemory( 2 * sizeof(Vertex) );
		vertices[0].u = i;
		vertices[0].v = 0;
		vertices[0].x = x + i * scale;
		vertices[0].y = y;
		vertices[1].u = i + SLICE_SIZE;
		vertices[1].v = sh;
		vertices[1].x = x + (i + SLICE_SIZE) * scale;
		vertices[1].y = y + sh * scale;
		sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
	}
	if (i < sw) {
		vertices = (Vertex*)sceGuGetMemory( 2 * sizeof(Vertex) );
		vertices[0].u = i;
		vertices[0].v = 0;
		vertices[0].x = x + i * scale;
		vertices[0].y = y;
		vertices[1].u = sw;
		vertices[1].v = sh;
		vertices[1].x = x + sw * scale;
		vertices[1].y = y + sh * scale;
		sceGuDrawArray( GU_SPRITES, GU_TEXTURE_16BIT | GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertices );
	}
	sceGuEnable( GU_DEPTH_TEST );
}

void DrawPicAlpha(int x, int y, DrawImg *image, float alpha, float scale)
{
	Color	*p;
	int		sw, sh;

	p = (Color*)image->data;
	sw = image->width;
	sh = image->height;
	DrawPicAlphaMain( x, y, image, p, sw, sh, alpha, scale);
}

void DrawPicAlpha2(int x, int y, DrawImg *image, int sx, int sy, int sw, int sh, float alpha, float scale)
{
	Color	*p;

	if (sx+sw > image->width) return;
	if (sy+sh > image->height) return;
	p = (Color*)image->data + sy * image->width + sx;
	DrawPicAlphaMain( x, y, image, p, sw, sh, alpha, scale);
}


//==============================================================
// GUɂ钼̍
//--------------------------------------------------------------

void DrawLineGu(int x1, int y1, int x2, int y2, Color cor, float alpha)
{
	Vertex3	*vertex;

	if (alpha > 1.0f) alpha = 1.0f;

	sceGuDisable( GU_DEPTH_TEST );
	sceGuDisable( GU_TEXTURE_2D );
	sceGuColor( (cor & 0x00FFFFFF) | ((int)(alpha * 255.0f) << 24) );
	vertex = (Vertex3*)sceGuGetMemory( 2 * sizeof(Vertex3) );
	vertex[0].x = x1;
	vertex[0].y = y1;
	vertex[1].x = x2;
	vertex[1].y = y2;
	sceGuDrawArray( GU_LINES, GU_VERTEX_16BIT | GU_TRANSFORM_2D, 2, NULL, vertex );
	sceGuEnable( GU_TEXTURE_2D );
}


//==============================================================
// GUɂlp`̍
//--------------------------------------------------------------

void DrawBoxGu(int x, int y, int sx, int sy, Color cor, float alpha)
{
	Vertex3	*vertex;

	if (alpha > 1.0f) alpha = 1.0f;

	sceGuDisable( GU_DEPTH_TEST );
	sceGuDisable( GU_TEXTURE_2D );
	sceGuColor( (cor & 0x00FFFFFF) | ((int)(alpha * 255.0f) << 24) );
	vertex = (Vertex3*)sceGuGetMemory( 5 * sizeof(Vertex3) );
	vertex[0].x = x + sx;
	vertex[0].y = y + sy;
	vertex[1].x = x + sx;
	vertex[1].y = y;
	vertex[2].x = x;
	vertex[2].y = y;
	vertex[3].x = x;
	vertex[3].y = y + sy;
	vertex[4].x = x + sx+1;										// ̈ʒuPhbgcH
	vertex[4].y = y + sy;
	sceGuDrawArray( GU_LINE_STRIP, GU_VERTEX_16BIT | GU_TRANSFORM_2D, 5, NULL, vertex );
	sceGuEnable( GU_TEXTURE_2D );
}


//==============================================================
// GUɂhԂꂽlp`̍
//--------------------------------------------------------------

void DrawBoxfillGu(int x, int y, int sx, int sy, Color cor, float alpha)
{
	Vertex3	*vertex;

	if (alpha > 1.0f) alpha = 1.0f;

	sceGuDisable( GU_DEPTH_TEST );
	sceGuDisable( GU_TEXTURE_2D );
	sceGuColor( (cor & 0x00FFFFFF) | ((int)(alpha * 255.0f) << 24) );
	vertex = (Vertex3*)sceGuGetMemory( 6 * sizeof(Vertex3) );
	vertex[0].x = x;
	vertex[0].y = y;
	vertex[1].x = x + sx;
	vertex[1].y = y;
	vertex[2].x = x + sx;
	vertex[2].y = y + sy;
	vertex[3].x = x;
	vertex[3].y = y;
	vertex[4].x = x + sx;
	vertex[4].y = y + sy;
	vertex[5].x = x;
	vertex[5].y = y + sy;
	sceGuDrawArray( GU_TRIANGLES, GU_VERTEX_16BIT | GU_TRANSFORM_2D, 6, NULL, vertex );
	sceGuEnable( GU_TEXTURE_2D );
}
