//==============================================================
// ̑̃c[ނ낢
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "fvTool.h"
#include <psputility.h>
#include <psprtc.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include "dialog.h"
#include "fileList.h"
#include "psp2chIni.h"
#include "charConv.h"
#include "psp2chAudio.h"
#include "fvDraw.h"
#include "sound.h"
#include "smemo/strInput.h"
#include "smemo/sime.h"
#include "unzip/FVunzip.h"
#include "FVunrar.h"

S_2CH s2ch;
char keyWords[128];
const char searchWords[] = "searchHistory.dat";


//==============================================================
// J[\ړ`FbN
//--------------------------------------------------------------

void psp2chCursorSet(int *pos, int count, int min)
{
	static int		keyStart = 0, keyRepeat = 0;
	static clock_t	keyTime = 0;
	static double	padStep = 0;
	int				padY, posBak;

	posBak = *pos;

	//----- pbhɂϗʈړ -----

	padY = s2ch.pad.Ly - 127;
	if (abs(padY) > s2ch.cfg.padCutoff) {
		padStep += ((padY > 0) - (padY < 0)) * (abs(padY) - s2ch.cfg.padCutoff) / 100.0;
		if (padStep > 1) {
			(*pos)++;
			padStep -= 1;
		} else if (padStep < -1) {
			(*pos)--;
			padStep += 1;
		}
	}

	//----- J[\L[ɂL[s[g -----

	if (s2ch.pad.Buttons != s2ch.oldPad.Buttons || keyRepeat) {
		if (s2ch.pad.Buttons != s2ch.oldPad.Buttons) {
			keyStart = 1;
		} else {
			keyStart = 0;
		}
		keyTime = sceKernelLibcClock();
		keyRepeat = 0;
		if (s2ch.pad.Buttons & PSP_CTRL_UP) {
			(*pos)--;
		} 
		else if (s2ch.pad.Buttons & PSP_CTRL_DOWN) {
			(*pos)++;
		}

	} else {
		if (keyStart) {
			if (sceKernelLibcClock() - keyTime > 300000) {
				keyRepeat = 1;
			}
		} else {
			if (sceKernelLibcClock() - keyTime > 10000) {
				keyRepeat = 1;
			}
		}
	}

	//----- ͈͊O̕␳ -----

	if (*pos < min) {
		*pos = min;
	} else if (*pos >= count) {
		*pos = count - 1;
	}
	if (count == 0 && min == 0) *pos = 0;

	//----- J[\ړ -----

	if (posBak != *pos) {										// ړ
		sound_play( eSE_MOVE );
	}
}


//==============================================================
// Simple IMEɂ镶
//--------------------------------------------------------------
// ۂ̏PSP͂̕ōsĂ܂B
//--------------------------------------------------------------

static int psp2chLInput(char *title, char *pretext, int type)
{
	char		file[FILE_PATH];
	int			ret;
	strInpHis	**inphis;
	SceCtrlData	pad;

	sprintf( file, "%s/%s", s2ch.cwDir, searchWords );
	inphis = InputHisLoad( file );								// 擾
	keyWords[0] = '\0';
	if (pretext != NULL) {
		strncpy( keyWords, pretext, sizeof(keyWords)-1 );
	}

	initGraphics();												// PSPp惂[h
	flipScreen();												// ftHgł̓y[Wݒɕsŝ
	sceCtrlPeekBufferPositive( &pad, 1 );
	SIMEgetchar( pad );											// Simple IMȄ͑΍
	ret = InputName( title, 50, type, keyWords, keyWords, inphis );
	if (!ret) {													// ̏ꍇ͗Ɍo^
		InputHisAdd( inphis, keyWords );
		InputHisSave( file, inphis );
	}
	pad.Buttons = 0;
	SIMEgetchar( pad );											// Simple IMENɂȂL[s[gȂ悤
	InputHisFree( inphis );										// 폜
	sceCtrlPeekBufferPositive( &s2ch.pad, 1 );
	s2ch.oldPad = s2ch.pad;										// ̌̃L[͎̃L[s[g΍

	return ret;
}


//==============================================================
// ̓_CAO\
//--------------------------------------------------------------
// text1: _CAOɕ\^Cg
// text2: OSKɕ\^Cg
// ߂l 0=, -1=
//--------------------------------------------------------------
// keyWords[]ɕ񂪕Ԃ
//--------------------------------------------------------------

int psp2chInputDialog(char *text1, char *text2, char *pretext)
{
	if (s2ch.cfg.inputType == 1) {
		return psp2chLInput( text1, pretext, 1 );				// OSKŃC
	}
	return psp2chLInput( text1, pretext, 0 );					// Simple IMEŃC
}


//==============================================================
// t@C
//--------------------------------------------------------------

int psp2chFileRead(SceUID fd, void *data, SceSize size)
{
	SceInt64	ret;

	ret = sceIoRead( fd, data, size );
	return ret;
}

int psp2chFileWrite(SceUID fd, const void *data, SceSize size)
{
	SceInt64	ret;

	ret = sceIoWrite( fd, data, size );
	if (ret != size) {
		MessageDialogText( "file write failed" );
	}
	return ret;
}


//==============================================================
// obNXbh𓮂
//--------------------------------------------------------------

void DoEvent()
{
	static clock_t	dotime = 0;

	if (sceKernelLibcClock() - dotime > 8000) {					// 8ms
		dotime = sceKernelLibcClock();
		sceKernelDelayThread( 1000 );							// 1ms~đ̃Xbh𓮂
	}
}


//==============================================================
// w肳ꂽpXɑΉTlCt@C擾
//--------------------------------------------------------------
// file2 FTlCt@Cւ̃tpX
// file  Ft@Cւ̃tpX
// ߂lF 0:I
//         -1:pX擾łȂ
//--------------------------------------------------------------

int getThumbName(char *file2, char *file)
{
	char	*p;
	int		pos;

	p = strchr( file, ':' );
	if (p) {													// hCu^[Ȃ
		pos = p - file + 1;
		strncpy( file2, file, pos );
		file2[pos] = '/';
		file2[pos+1] = '\0';
		strcat( file2, THUMBFOLDER );							// TlCtH_
		strcat( file2, &file[pos] );							// TlCۑĂnỸtH_
		strcat( file2, ".dat" );								// TlCt@Cւ̃tpX
		return 0;
	} else {													// hCu^[Ȃi肦ȂnYj
		return -1;
	}
}


//==============================================================
// A[JCupX[hTlCt@C֕ۑ
//--------------------------------------------------------------

void writeArcPass(char *file, char *pass)
{
	SceUID			fd;
	unsigned short	buf[260];
	char			*p, path[1024], thFile[1024];
	int				len;

	len = strlen(pass);
	if (s2ch.cfg.arcPass && len>0 && len<256) {					// pX[hۑ
		if (getThumbName(thFile,file) == 0) {
			buf[0] = THUMBID | 0x0200;
			buf[1] = 0x5350;
			strcpy( (char*)&buf[2], pass );
			p = strrchr( thFile, '/' );
			if (p) {
				strncpy( path, thFile, p - thFile );
				path[p - thFile] = '\0';
				if (makedir(path)) {							// wtH_̐ɐ
					fd = sceIoOpen( thFile, PSP_O_WRONLY | PSP_O_CREAT | PSP_O_TRUNC, FILE_PARMISSION );
					sceIoWrite( fd, buf, len + 4 );
					sceIoClose(fd);
				}
			}
		}
	}
}


//==============================================================
// A[JCupX[hTlCt@C擾
//--------------------------------------------------------------

void readArcPass(char *pass, char *file)
{
	SceUID			fd;
	unsigned short	buf[260];
	char			path[1024];
	int				size;

	*pass = '\0';
	if (getThumbName(path,file) == 0) {							// TlCt@CpX[h擾
		fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
		if (fd >= 0) {
			size = sceIoRead( fd, buf, sizeof(buf) );
			if (size > 4) {
				if (buf[0]==(THUMBID | 0x0200) && buf[1]==0x5350) {
					strncpy( pass, (char*)&buf[2], size - 4 );
					pass[size - 4] = '\0';
				}
			}
			sceIoClose(fd);
		}
	}
}


//==============================================================
// A[JCuɓWJ
//--------------------------------------------------------------
// ߂l  NULL:G[
//         ȊO:WJꂽf[^
// size    WJꂽf[^TCY
//--------------------------------------------------------------

char *expandToMem(char *file, DirList *DList, int *size)
{
	char	*work, pass[256], msg[1024];
	int		ret;

	*size = 0;
	msg[0] = '\0';
	strcpy( pass, DList->archivePass );
	if (DList->archiveType == 1) {								// zipA[JCu
		ret = unzipToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
		if (ret == -3) {										// pX[hႤ
			if (pspOSKDialog("zipt@C̃pX[h", pass, 256, 1)!=2) {
				return NULL;									// LZꂽ
			}
			ret = unzipToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
			if (ret == -3) {									// ςpX[hႤ
				MessageDialogText( "%s\npX[hv܂", DList->archiveFile );
				return NULL;
			} else if (ret < 0) {								// pX[hȊÕG[
				MessageDialogText(msg);
				return NULL;
			}
			strcpy( DList->archivePass, pass );
			writeArcPass( DList->archiveFile, pass );			// pX[h̕ۑ
		} else if (ret < 0) {
			MessageDialogText(msg);
			return NULL;
		}
	} else {													// rarA[JCu
		ret = unrarPass( DList->archiveFile, &file[strlen(DList->archiveFile)+1] );
		if (ret == -1) {
			MessageDialogText( "%s\nrart@CJ܂iĂHj", DList->archiveFile );
			return NULL;
		} else if (ret == 1) {									// pX[hKvȂ̂
			MessageDialogText( "%s\npX[hݒ肳Ă邽߃ANZXł܂", file );
			return NULL;
		}
		ret = unrarToMemory( DList->archiveFile, &file[strlen(DList->archiveFile)+1], &work, pass, msg );
		if (ret < 0) {
			MessageDialogText(msg);
			return NULL;
		}
	}
	*size = ret;

	return work;
}


//==============================================================
// t@C̊gq̔
//--------------------------------------------------------------
// ߂lF0 `9 :摜t@C
//         10`29:t@C
//         30`49:t@C
//         50`89:eLXgt@C
//         90`98:A[JCut@C
//         99    :gqȂ
//         100   :̑̃t@C
//--------------------------------------------------------------

int checkExt(char *path)
{
	char	*p;

	p = strrchr( path, '.' );
	if (p == NULL) return 99;

	if (stricmp(p, ".jpg") == 0 || stricmp(p, ".jpeg") == 0) {
		return 0;
	} else if (stricmp(p, ".png") == 0) {
		return 1;
	} else if (stricmp(p, ".gif") == 0) {
		return 2;
	} else if (stricmp(p, ".bmp") == 0) {
		return 3;
	} else if (stricmp(p, ".mp3") == 0) {
		return EXT_TYPE_SOUND-20;
	} else if (stricmp(p, ".txt") == 0) {
		return EXT_TYPE_TEXT-40;
	} else if (stricmp(p, ".ini") == 0) {
		return EXT_TYPE_TEXT-40 + 1;
	} else if (stricmp(p, ".cfg") == 0) {
		return EXT_TYPE_TEXT-40 + 2;
	} else if (stricmp(p, ".zip") == 0) {
		return EXT_TYPE_ARCHIVE-9;
	} else if (stricmp(p, ".rar") == 0) {
		return EXT_TYPE_ARCHIVE-9 + 1;
	}
	return 100;
}


//==============================================================
// ΉACRNo擾
//--------------------------------------------------------------

int getIconNo(char *path)
{
	int		type, icon;

	type = checkExt(path);
	icon = 2;
	if (type < EXT_TYPE_IMAGE) {			// 摜t@C
		icon = 3;
	} else if (type < EXT_TYPE_SOUND) {		// t@C
		icon = 4;
	} else if (type < EXT_TYPE_MOVIE) {		// t@C
		
	} else if (type < EXT_TYPE_TEXT) {		// eLXgt@C
		icon = 5;
	}
	return icon;
}
