//==============================================================
// BGMt@CĐ
//--------------------------------------------------------------

#include "FreezeViewer.h"
#include "fvTool.h"
#include <psputility.h>
#include <pspaudio.h>
#include <pspmp3.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <malloc.h>
#include "mp3Audio.h"
#include "charConv.h"
#include "fvView.h"

#define MP3_BUF_SIZE (1024 * 32 + 1472)
#define PCM_BUF_SIZE (1152 * 32)
#define FILE_END 0x80671402

extern S_2CH s2ch;												// fvTool.c

typedef struct {
	int		running;
	SceUID	fd;
	int		handle;
	char	startDir[FILE_PATH];
	char	playDir[FILE_PATH];
	char	playName[FILE_PATH];
	int		full_semaid;
	int		empty_semaid;
	int		bytesDecoded;
	short	*outBuf;
} mp3_data;

typedef union {													// mpegwb_\
	char	cHeader[4];
	struct {
		unsigned int	sinc1:8;								// wb_(0xff)

		unsigned int	err:1;									// G[veNV
		unsigned int	layer:2;								// C
		unsigned int	id:1;									// ID
		unsigned int	sinc2:4;								// wb_(0xf)

		unsigned int	ext:1;									// GNXeVilʃtOj
		unsigned int	padding:1;								// pfBO
		unsigned int	sampling:2;								// TvO[g
		unsigned int	bitrate:4;								// rbg[g

		unsigned int	enfa:2;									// Gt@VX
		unsigned int	original:1;								// IWi^Rs[
		unsigned int	copyright:1;							// 쌠
		unsigned int	mode:2;									// [hGNXeV
		unsigned int	channel:2;								// `l[h
	} h;
} mpeg_head;

volatile strBgm gBGM;											// BGMǗ\

static int playThread;
static int decodeThread;
static mp3_data playData = {1, -1, -1, "", "", "", -1, -1, -1, NULL};

static int mp3fillStreamBuffer(SceSize args, void *argp);
static int mp3PlayThread(SceSize args, void *argp);
static int audioPlayEnd(void);


//==============================================================
// BGMvpeB̃NA
//--------------------------------------------------------------
// WPbg摜ibgm.pvj͂ł̓NAȂ
//--------------------------------------------------------------

void bgmPropertyClear(strBgm *bgm)
{
	bgm->type = 0;
	bgm->tag = 0;
	bgm->title[0] = '\0';
	bgm->artist[0] = '\0';
	bgm->album[0] = '\0';
	bgm->year[0] = '\0';
	bgm->comment[0] = '\0';
	bgm->pos = 0;
	bgm->time = 0;
	bgm->SamplingRate = 0;
	bgm->bitRate = 0;
	bgm->mLayer = 0;
	bgm->mID = 0;
	bgm->channel = 0;
	bgm->vbr = 0;
	bgm->frame = 0;
	bgm->imageType = 0;
	free( bgm->data );
	bgm->data = NULL;
	bgm->dataSize = 0;
	free( bgm->info );
	bgm->info = NULL;
}


//==============================================================
// MP3ID3v2^O擾
//--------------------------------------------------------------
// textF ^Oi[ziUTF8j
// frameFID3v2t[
//--------------------------------------------------------------

//===== UTF-16̎荞 =====

static int getTagUTF16(unsigned char *text, int textSize, unsigned char *frame, long frameSize)
{
	char	utf8[4];
	int		i, pos, textPos, bom, step;

	pos = 0;
	bom = 0;													// ftHg̓rbOGfBA
	if (frame[0]==0xFF && frame[1]==0xFE) {
		bom = 1;												// gGfBA
		pos += 2;
	} else if (frame[0]==0xFE && frame[1]==0xFF) {
		bom = 0;												// rbOGfBA
		pos += 2;
	}
	textPos = 0;
	while (textPos<textSize-1 && pos<frameSize-1 && !(frame[pos]=='\0' && frame[pos+1]=='\0')) {
		if (bom) {												// gGfBA
			step = ucs2utf8( utf8, frame[pos] + (frame[pos+1]<<8) );
		} else {												// rbOGfBA
			step = ucs2utf8( utf8, (frame[pos]<<8) + frame[pos+1] );
		}
		pos += 2;
		if (textPos+step >= textSize) break;					// obt@TCY𒴂Ȃ
		for (i = 0; i < step; i++) {
			text[textPos++] = utf8[i];
		}
	}
	text[textPos] = '\0';
	if (frame[pos] == '\0') pos += 2;
	return pos;
}

//===== GR[fBO̎wɏ]UTF8ɕϊȂ荞 =====

static int getEncodeString(unsigned char *text, int textSize, unsigned char *frame, long frameSize, int pos, int codeType )
{
	int		textPos;

	switch (codeType) {
	case 0:														// ISO-8859-1 (Shift-JIS)
		pos += Sjis2UTF8Len( text, textSize, &frame[pos], frameSize-pos );
		break;

	case 1:														// UTF-16 / BOM
	case 2:														// UTF-16BE / BOMȂ
		pos += getTagUTF16( text, textSize, &frame[pos], frameSize-pos );
		break;

	case 3:														// UTF-8
		textPos = 0;
		while (textPos<textSize-1 && pos<frameSize && frame[pos]) {
			text[textPos++] = frame[pos++];
		}
		text[textPos] = '\0';
		if (frame[pos] == '\0') pos++;
		break;
	}
	return pos;
}

//===== wő啶ȓŃ^O荞 =====

static void getTag(unsigned char *text, int textSize, unsigned char *frame, long frameSize, char type)
{
	int		pos, codeType;

	codeType = frame[0];
	if (type == 'T') {											// eLXgn
		pos = 1;
	} else if (type == 'C') {									// Rg
		pos = 1;												// 
		if (codeType==1 || codeType==2) {
			while (!(frame[pos]=='\0' && frame[pos+1]=='\0') && pos<frameSize) {
				pos++;
			}
			if (frame[pos] == '\0') pos += 2;					// Zk
		} else {
			while (frame[pos]!='\0' && pos<frameSize) {
				pos++;
			}
			if (frame[pos] == '\0') pos++;						// Zk
		}
	} else {													// Ӗ͂Ȃ
		pos = 1;
	}

	getEncodeString( text, textSize, frame, frameSize, pos, codeType );
}

//===== ID3v2t[w^O =====

static int getMP3tag(unsigned char *text, int textSize, unsigned char *frame, long frameSize, int pos, char *tag, int ver)
{
	int		tagLen, tagSize;

	tagLen = strlen( tag );
	while ((frame[pos]>='0' && frame[pos]<='z') && pos < frameSize) {	// t[͈͈ȓȂ
		if (ver <= 2) {											// ID3v2.2
			tagSize = (frame[pos+3]<<16) + (frame[pos+3+1]<<8) + frame[pos+3+2] + 6;
		} else if (ver == 3) {									// ID3v2.3
			tagSize = (frame[pos+4]<<24) + (frame[pos+4+1]<<16) + (frame[pos+4+2]<<8) + frame[pos+4+3];
		} else {												// ID3v2.4ȍ~
			tagSize = (frame[pos+4]<<21) + (frame[pos+4+1]<<14) + (frame[pos+4+2]<<7) + frame[pos+4+3];
		}
		if (strncmp(&frame[pos], tag, tagLen) == 0) {			// w肳ꂽ^O𔭌
			if (ver <= 2) {										// ID3v2.2
				getTag( text, textSize, &frame[pos+6], tagSize, *tag );
			} else {											// ID3v2.3ȍ~
				getTag( text, textSize, &frame[pos+10], tagSize, *tag );
			}
			return 1;											// ^O̂ŏI
		}
		tagSize += 10;
		pos += tagSize;											// ̃^Oʒu
	}

	return 0;													// w^O͖
}

//===== WPbg摜荞 =====

static unsigned char *getPic(long *dataSize, int *imageType, unsigned char *frame, long frameSize, int ver)
{
	unsigned char	*data, mime[16];
	int				pos, mimeSize, codeType;

	if (ver == 2) {																// image format̒
		mimeSize = 3;
	} else {
		mimeSize = 16;
	}
	codeType = frame[0];
	pos = 1;
	pos = getEncodeString( mime, mimeSize, frame, frameSize, pos, codeType );	// image format / MIME type
	if (strstr(mime,"PNG") || strstr(mime,"png")) {
		*imageType = 2;
	} else if (strstr(mime,"JPG") || strstr(mime,"jpeg")) {
		*imageType = 1;
	}

	pos++;																		// Picture typeij

	pos = getEncodeString( mime, 16, frame, frameSize, pos, codeType );			// Descriptionij
	*dataSize = frameSize - pos;
	data = malloc( *dataSize );
	if (data) {
		memcpy( data, &frame[pos], *dataSize );									// WPbg摜f[^ۑ
		return data;
	} else {																	// 摜f[^pmۂłȂ
		*dataSize = 0;
		*imageType = 0;
		return NULL;
	}
}

//===== ID3v2t[w^OiWPbg摜j =====

static unsigned char *getMP3tag2(long *dataSize, int *imageType, unsigned char *frame, long frameSize, int pos, char *tag, int ver)
{
	unsigned char	*data;
	int				ret, tagLen, tagSize;

	tagLen = strlen( tag );
	while ((frame[pos]>='0' && frame[pos]<='z') && pos < frameSize) {	// t[͈͈ȓȂ
		if (ver <= 2) {											// ID3v2.2
			tagSize = (frame[pos+3]<<16) + (frame[pos+3+1]<<8) + frame[pos+3+2] + 6;
		} else if (ver == 3) {									// ID3v2.3
			tagSize = (frame[pos+4]<<24) + (frame[pos+4+1]<<16) + (frame[pos+4+2]<<8) + frame[pos+4+3];
		} else {												// ID3v2.4ȍ~
			tagSize = (frame[pos+4]<<21) + (frame[pos+4+1]<<14) + (frame[pos+4+2]<<7) + frame[pos+4+3];
		}
		if (strncmp(&frame[pos], tag, tagLen) == 0) {			// w肳ꂽ^O𔭌
			if (ver <= 2) {										// ID3v2.2
				data = getPic( dataSize, imageType, &frame[pos+6], tagSize, ver );
			} else {											// ID3v2.3ȍ~
				data = getPic( dataSize, imageType, &frame[pos+10], tagSize, ver );
			}
			return data;										// ^O̂ŏI
		}
		tagSize += 10;
		pos += tagSize;											// ̃^Oʒu
	}

	return NULL;												// w^O͖
}


//==============================================================
// MP3t@C̃^O擾
//--------------------------------------------------------------

void getMP3FileTag(SceUID fd, strBgm *bgm, int *start, int *end)
{
	char			*info;
	unsigned char	head[12], *frame;
	long			frameSize;
	mpeg_head		mHead;
	const int		bitrateTbl[2][3][14] = {					// rbg[gZe[u
		{
			{ 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160 },
			{ 8, 16, 24, 32, 40, 48, 56, 64, 80, 96, 112, 128, 144, 160 },
			{ 32, 48, 56, 64, 80, 96, 112, 128, 144, 160, 176, 192, 224, 256 },
		}, {
			{ 32, 40, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320 },
			{ 32, 48, 56, 64, 80, 96, 112, 128, 160, 192, 224, 256, 320, 384 },
			{ 32, 64, 96, 128, 160, 192, 224, 256, 288, 320, 352, 384, 416, 448 },
		}
	};
	const int		samplingTbl[2][3] = {						// TvO[gZe[u
		{ 22050, 24000, 16000 },								// mpeg2
		{ 44100, 48000, 32000 },								// mpeg1
	};

	bgmPropertyClear( bgm );
	*start = 0;
	*end = sceIoLseek32( fd, 0, SEEK_END );
	sceIoLseek32( fd, 0, SEEK_SET );
	sceIoRead( fd, head, 10 );									// ID3v2wb_ǂݍ
	if (head[0] == 'I' && head[1] == 'D' && head[2] == '3') {	// ID3v2
		bgm->type = 1;											// MP3t@C
		bgm->tag = head[3];										// ^Oo[W
		frameSize = (head[6] << 21) + (head[7] << 14) + (head[8] << 7) + head[9];
		*start = frameSize + 10;
		frame = malloc( frameSize );
		if (frame) {
			int		pos;
			sceIoRead( fd, frame, frameSize );					// ID3v2^Oǂݍ
			pos = 0;
			if (head[5] & 0x20) {								// gwb_L
				if (bgm->tag <= 3) {							// ID3v2.3ȑOȂ
					pos = (frame[0]<<24) + (frame[1]<<16) + (frame[2]<<8) + frame[3];
				} else {										// ID3V2.4ȍ~Ȃ
					pos = (frame[0]<<21) + (frame[1]<<14) + (frame[2]<<7) + frame[3];
				}
			}
			if (bgm->tag <= 2) {								// ID3v2.2
				getMP3tag( bgm->title,   125, frame, frameSize, pos, "TT2", bgm->tag );
				getMP3tag( bgm->artist,  125, frame, frameSize, pos, "TP1", bgm->tag );
				getMP3tag( bgm->album,   125, frame, frameSize, pos, "TAL", bgm->tag );
				getMP3tag( bgm->year,    5,   frame, frameSize, pos, "TYE", bgm->tag );
				getMP3tag( bgm->comment, 125, frame, frameSize, pos, "COM", bgm->tag );
				bgm->data = getMP3tag2( &bgm->dataSize, &bgm->imageType, frame, frameSize, pos, "PIC", bgm->tag );
			} else {											// ID3v2.3ȍ~
				getMP3tag( bgm->title,   125, frame, frameSize, pos, "TIT2", bgm->tag );
				getMP3tag( bgm->artist,  125, frame, frameSize, pos, "TPE1", bgm->tag );
				getMP3tag( bgm->album,   125, frame, frameSize, pos, "TALB", bgm->tag );
				getMP3tag( bgm->year,    5,   frame, frameSize, pos, "TYER", bgm->tag );
				getMP3tag( bgm->comment, 125, frame, frameSize, pos, "COMM", bgm->tag );
				bgm->data = getMP3tag2( &bgm->dataSize, &bgm->imageType, frame, frameSize, pos, "APIC", bgm->tag );
			}
			free( frame );
		}
	}
	sceIoLseek32( fd, -128, SEEK_END );
	sceIoRead( fd, head, 3 );
	if (head[0] == 'T' && head[1] == 'A' && head[2] == 'G') {	// ID3v1
		*end -= 128;
		if (bgm->tag == 0) {									// ID3v2^O擾ĂȂȂ
			char	buf[31];
			bgm->type = 1;										// MP3t@C
			bgm->tag = 1;										// ID3v1^O
			sceIoRead( fd, buf, 30 );							// ȃ^Cg
			Sjis2UTF8Len( bgm->title, 30, buf, 30 );
			sceIoRead( fd, buf, 30 );							// ȃA[eBXg
			Sjis2UTF8Len( bgm->artist, 30, buf, 30 );
			sceIoRead( fd, buf, 30 );							// ȃAo
			Sjis2UTF8Len( bgm->album, 30, buf, 30 );
			sceIoRead( fd, bgm->year, 4 );						// ȐN
			bgm->year[4] = '\0';
		}
	}

	sceIoLseek32( fd, *start, SEEK_SET );						// mpegt[wb_ʒu
	sceIoRead( fd, mHead.cHeader, 4 );
	bgm->mID = mHead.h.id;										// mpeg2 / mpeg1
	bgm->mLayer = mHead.h.layer;								// C[
	if (mHead.h.sampling < 3) {									// TvO[g
		bgm->SamplingRate = samplingTbl[bgm->mID][mHead.h.sampling];
	}
	if (mHead.h.bitrate > 0 && mHead.h.bitrate <= 14 && bgm->mLayer != 0) {	//rbg[g
		bgm->bitRate = bitrateTbl[bgm->mID][bgm->mLayer - 1][mHead.h.bitrate - 1];
	}
	bgm->channel = mHead.h.channel;								// `l
	if (bgm->channel == 3) {									// mȂ
		sceIoLseek32( fd, *start +21, SEEK_SET );				// mpegt[Jnʒu
	} else {													// XeIȂ
		sceIoLseek32( fd, *start +36, SEEK_SET );				// mpegt[Jnʒu
	}
	sceIoRead( fd, head, 12 );									// <Xing>wb_͂̏ꏊ
	if (strncmp(head, "Xing", 4) == 0) {						// <Xing>wb_
		if (head[7] & 0x01) {									// t[L
			bgm->vbr = 1;
			bgm->frame = (head[8]<<24) + (head[9]<<16) + (head[10]<<8) + head[11];
		}
	}

	if (bgm->vbr) {												// σrbg[g̏ꍇ
		if (bgm->SamplingRate) {
			bgm->time = bgm->frame * 115200 / bgm->SamplingRate;
		}
	} else {													// Œrbg[g̏ꍇ
		if (bgm->bitRate) {
			bgm->time = (*end - *start) * 8 / bgm->bitRate / 10;
		}
	}

	//-----  -----

	const char	tagType[][8] = { "", "ID3v1", "ID3v2.2", "ID3v2.3", "ID3v2.4" };
	const char	layer[][10] = { "", "Layer-3", "Layer-2", "Layer-1" };
	const char	mpeg[][6] = { "MPEG-2", "MPEG-1" };
	const char	chan[][14] = { "stereo", "joint stereo", "dual channel", "monaural" };
	const char	encode[][4] = { "CBR", "VBR" };

	info = malloc( 256 );
	if (!info) return;
	sprintf( info, "FileType : %s\nTagType : %s\nLayer : %s\nMPEG : %s\nChannel : %s\nEncodeType : %s\nmpegFrame : %d",
	               "MP3", tagType[bgm->tag], layer[bgm->mLayer], mpeg[bgm->mID], chan[bgm->channel], encode[bgm->vbr], bgm->frame );
	bgm->info = info;
}


//==============================================================
// MP3f[^obt@ǂݍ
//--------------------------------------------------------------

static int mp3fillStreamBuffer(SceSize args, void *argp)
{
	mp3_data	*data = *(mp3_data**)argp;
	short		*playBuf[2];
	SceUChar8*	dst;
	int			write, pos, swap = 0;
	SceInt64	ret;
	short		*buf;

	playBuf[0] = memalign( 64, sizeof(short) * PCM_BUF_SIZE );
	playBuf[1] = memalign( 64, sizeof(short) * PCM_BUF_SIZE );
	if (playBuf[0] == NULL || playBuf[1] == NULL) {
		free( playBuf[0] );
		free( playBuf[1] );
		return 0;
	}

	while (1) {
		sceKernelWaitSema( data->empty_semaid, 1, NULL );
		sceKernelSignalSema( data->empty_semaid, 0 );
		if (sceMp3CheckStreamDataNeeded(data->handle) > 0) {
			if (sceMp3GetInfoToAddStreamData(data->handle, &dst, &write, &pos) < 0) {
				break;
			}
			sceIoLseek32( data->fd, pos, SEEK_SET );
			ret = sceIoRead( data->fd, dst, write );
			if (ret < 0) {
				break;
			}
			if (sceMp3NotifyAddStreamData(data->handle, ret) < 0) {
				break;
			}
		}
		if (data->bytesDecoded > 0) {
			data->bytesDecoded = sceMp3Decode( data->handle, &buf );
			memcpy( playBuf[swap], buf, data->bytesDecoded );
			data->outBuf = playBuf[swap];
			swap = 1 - swap;
			gBGM.bitRate = sceMp3GetBitRate( data->handle );
		}
		sceKernelSignalSema( data->full_semaid, 1 );
	}
	free( playBuf[0] );
	free( playBuf[1] );
	return (pos > 0);
}


//==============================================================
// MP3ĐXbh
//--------------------------------------------------------------

static int mp3PlayThread(SceSize args, void *argp)
{
	char			*mp3Buf;
	short			*pcmBuf;
	int				lastDecoded = 0;
	int				volume = PSP_AUDIO_VOLUME_MAX;
	SceMp3InitArg	mp3Init;
	int				start, end;
	int				channel = -1;
	int				numChannels, ret;
	unsigned char	head[12], path[FILE_PATH];
	mp3_data		*data = *(mp3_data**)argp;

	mp3Buf = memalign( 64, sizeof(char) * (MP3_BUF_SIZE) );
	pcmBuf = memalign( 64, sizeof(short) * PCM_BUF_SIZE );
	if (mp3Buf == NULL || pcmBuf == NULL) {
		free( mp3Buf );
		free( pcmBuf );
		sceKernelExitThread( 0 );
		return -1;
	}

	do {
		// t@CI[v
		strcpy( path, data->playDir );
		strcat( path, "/" );
		strcat( path, data->playName );
		data->fd = sceIoOpen( path, PSP_O_RDONLY, FILE_PARMISSION );
		if (data->fd < 0) {
			bgmPropertyClear( &gBGM );
			break;
		}
		strcpy( s2ch.bgmFile, path );							// ݍĐ̃t@C
		gBGM.bgmID++;											// BGMɕω
		getMP3FileTag( data->fd, &gBGM, &start, &end );			// MP3̃^O擾

		// MP3̏ݒ
		if (sceMp3InitResource() < 0) {
			sceIoClose( data->fd );
			bgmPropertyClear( &gBGM );
			break;
		}
		mp3Init.mp3StreamStart = start;
		mp3Init.mp3StreamEnd = end;
		mp3Init.unk1 = 0;
		mp3Init.unk2 = 0;
		mp3Init.mp3Buf = mp3Buf;
		mp3Init.mp3BufSize = MP3_BUF_SIZE;
		mp3Init.pcmBuf = pcmBuf;
		mp3Init.pcmBufSize = PCM_BUF_SIZE;
		data->handle = sceMp3ReserveMp3Handle( &mp3Init );
		if (data->handle < 0) {
			sceMp3TermResource();
			sceIoClose( data->fd );
			bgmPropertyClear( &gBGM );
			break;
		}
		data->bytesDecoded = 0;
		data->full_semaid = sceKernelCreateSema( "full_sema", 0, 0, 1, 0 );
		data->empty_semaid = sceKernelCreateSema( "empty_sema", 0, 1, 1, 0 );
		sceKernelStartThread( decodeThread, sizeof(mp3_data**), &data );
		sceKernelWaitSema( data->full_semaid, 1, NULL );
		sceKernelSignalSema( data->full_semaid, 0 );
		ret = sceMp3Init( data->handle );
		if (ret < 0) {
			sceKernelTerminateThread( decodeThread );
			sceKernelDeleteSema( data->empty_semaid );
			sceKernelDeleteSema( data->full_semaid );
			sceMp3ReleaseMp3Handle( data->handle );
			sceMp3TermResource();
			sceIoClose( data->fd );
			bgmPropertyClear( &gBGM );
			break;
		}
		data->bytesDecoded = 1;
		sceKernelSignalSema( data->empty_semaid, 1 );
		sceMp3SetLoopNum( data->handle, 0 );					// -1:[v 0:Pȃ[v
		numChannels = sceMp3GetMp3ChannelNum( data->handle );

		// ĐJn
		for (;;) {
			if (data->running) {
				if (data->running == 6) {
					sceMp3ResetPlayPosition( data->handle );	// ĐʒuZbg
					gBGM.pos = 0;
					data->running = 0;
					continue;
				}
				if (data->running == 2) {						// ꎞ~
					sceKernelSleepThread();
					continue;
				}
				break;
			}
			SceUInt timeout = DISPLAY_WAIT;
			if (sceKernelWaitSema(data->full_semaid, 1, &timeout) < 0) { // ǂݍ
				break;
			}
			sceKernelSignalSema( data->full_semaid, 0 );
			if (data->bytesDecoded <= 0) {						// decode error
				if (data->bytesDecoded == 0 || data->bytesDecoded == (int)FILE_END) {	// file end
					sceMp3ResetPlayPosition( data->handle );
					gBGM.pos = 0;
					data->running = 3;
				}
				break;
			} else {
				if (channel < 0 || lastDecoded != data->bytesDecoded) {
					if (channel >= 0) {
						sceAudioChRelease( channel );
					}
					channel = sceAudioChReserve( PSP_AUDIO_NEXT_CHANNEL, 1152, PSP_AUDIO_FORMAT_STEREO );
				}
				lastDecoded = data->bytesDecoded;
				while (sceAudioGetChannelRestLength(channel)) {
					sceKernelDelayThread(1000);
				}
				gBGM.pos += sceAudioOutput( channel, volume, data->outBuf );
				sceKernelSignalSema( data->empty_semaid, 1 );
			}
		}
		// I
		if (channel >= 0) {
			sceAudioChRelease( channel );
			channel = -1;
		}
		sceKernelTerminateThread( decodeThread );
		sceKernelDeleteSema( data->full_semaid );
		sceKernelDeleteSema( data->empty_semaid );
		sceKernelDelayThread( 100000 );
		sceMp3ReleaseMp3Handle( data->handle );
		sceMp3TermResource();
		sceIoClose( data->fd );
	} while (audioPlayEnd() == 0);

	gBGM.bgmID++;												// BGMɕω
	free( pcmBuf );
	free( mp3Buf );
	sceKernelExitThread( 0 );
	return 0;
}

//==============================================================
// TutH_܂߂Ďmp3t@CT
//--------------------------------------------------------------
// subDirFlagFTutH_T邩
//   0    Ȃ
//   ȊO 
// revFlagF   T
//   0    
//   ȊO t
//--------------------------------------------------------------

static void audioPlaySearch(char *playDir, int *next, char *play_1st, char *play_next, int subDirFlag, int revFlag)
{
	mp3_data	*data = &playData;
	SceUID		dfd;
	SceIoDirent	dir;
	char		*p, path[FILE_PATH];

	dfd = sceIoDopen( playDir );
	if (dfd < 0) return;
	memset( &dir, 0, sizeof(dir) );
	while (sceIoDread(dfd, &dir) > 0) {
		if (strcmp(dir.d_name, ".") == 0) continue;
		if (strcmp(dir.d_name, "..") == 0) continue;
		if (dir.d_stat.st_attr & FIO_SO_IFDIR) {				// fBNg̏ꍇ
			if (subDirFlag) {									// TufBNgTȂ
				strcpy( path, playDir );
				strcat( path, "/" );
				strcat( path, dir.d_name );
				audioPlaySearch( path, next, play_1st, play_next, 1, revFlag );
				if (*next == 2) break;							// TufBNgŎ̃t@C
			}
		} else {												// t@C̏ꍇ
			p = strrchr( dir.d_name, '.' );
			if (p) {
				if (stricmp(p, ".mp3") == 0) {
					if (revFlag) {								// tT
						if (strcmp(dir.d_name, data->playName) == 0) {
							if (play_next[0]) {					// Õt@C擾ĂȂ
								*next = 2; 						// 
								break;
							}
						}
						strcpy( play_next, dir.d_name );
						strcpy( play_1st, dir.d_name );
						strcpy( data->playDir, playDir );
					} else {									// T
						if (!play_1st[0]) {
							strcpy( play_1st, dir.d_name );
							strcpy( data->playDir, playDir );	// 肠ŏɌt@C̃fBNgʒuɃZbg
						}
						if (*next) {
							*next = 2; 							// 
							strcpy( play_next, dir.d_name );
							strcpy( data->playDir, playDir );	// Ώۃt@C̃fBNgʒuZbg
							break;
						}
						if (strcmp(dir.d_name, data->playName) == 0) {
							*next = 1; 							// ̌₪Ώ
						}
					}
				}
			}
		}
	}
	sceIoDclose( dfd );
}

//===== mp3t@C =====

static int audioPlayEnd(void)
{
	mp3_data	*data = &playData;
	int			next = 0, revFlag = 0;
	char		play_1st[FILE_PATH] = {0}, play_next[FILE_PATH] = {0};

	if (data->running < 3 || data->running > 5) {
		return -1;												// ĐȂ玟̋ȂɍsȂ
	}
	if (data->running == 4) {									// ̋
		revFlag = 0;
	} else if (data->running == 5) {							// Ő
		revFlag = 1;
	}

	switch (s2ch.cfg.bgmLoop) {
	case 0:														// [vȂ
		if (data->running==4 || data->running==5) {
			audioPlaySearch( data->startDir, &next, play_1st, play_next, 1, revFlag );
		} else {
			data->running = 0;
			return -1;
		}
		break;
	case 1:														// Pȃ[v
		if (data->running==4 || data->running==5) {
			audioPlaySearch( data->startDir, &next, play_1st, play_next, 1, revFlag );
		} else {
			data->running = 0;
			return 0;
		}
		break;
	case 2:														// tH_Ŏ̋
		audioPlaySearch( data->startDir, &next, play_1st, play_next, 0, revFlag );
		break;
	case 3:														// TutH_܂ݎ̋
		audioPlaySearch( data->startDir, &next, play_1st, play_next, 1, revFlag );
		break;
	case 4:														// wtH_ȉŎ̋
		audioPlaySearch( s2ch.cfg.bgmDir, &next, play_1st, play_next, 1, revFlag );
		break;
	}

	if (next == 2) {											// ̋Ȃ
		strcpy( data->playName, play_next );
	} else {													// Ȃ̂ōŏɌ
		strcpy( data->playName, play_1st );
	}
	data->running = 0;
	return 0;
}


//==============================================================
// ݒ
//--------------------------------------------------------------


int audioInit(iniList *ini)
{
	char		msg[256];

	s2ch.bgmFile[0] = '\0';
	bgmPropertyClear( &gBGM );
	freeTexMem( &gBGM.pv );										// WPbg摜p

	strcpy( msg, "AV module (" );
	if (sceUtilityLoadModule(PSP_MODULE_AV_AVCODEC) < 0) {
		strcat( msg, "AV_AVCODEC" );
	}
	if (sceUtilityLoadModule(PSP_MODULE_AV_MP3) < 0) {
		if (strlen(msg)!=11) strcat( msg, "," );
		strcat( msg, "AV_MP3" );
	}
	if (strlen(msg) != 11) {
		strcat( msg,") load error" );
		strcpy( ini->msg[ini->phase], msg );
	}
	playThread = sceKernelCreateThread( "mp3_play_thread", (SceKernelThreadEntry)&mp3PlayThread, 0x1F, 0x4000, 0, NULL );
	if (playThread < 0) {
		ini->error = -1;
		return -1;
	}
	decodeThread = sceKernelCreateThread( "mp3_decode_thread", (SceKernelThreadEntry)&mp3fillStreamBuffer, 0x1F, 0x0800, 0, NULL );
	if (decodeThread < 0) {
		ini->error = -1;
		return -1;
	}
	return 0;
}


//==============================================================
// Đ/ꎞ~
//--------------------------------------------------------------
// w肳ꂽMP3t@CĐB
// pathnullw肳ꂽꍇ͈ꎞ~/Đ
//--------------------------------------------------------------

int audioPlay(const char *path, const char *name)
{
	mp3_data	*data = &playData;

	//----- t@Cw肳ĂȂ -----

	if (path==NULL || name==NULL) {
		switch (data->running) {
		case 0:													// ĐȂꎞ~
			data->running = 2;
			return 0;
			break;
		case 1:													// ~ȂBGMtH_Đ
			break;
		case 2:													// ꎞ~ȂĊJ
			data->running = 0;
			sceKernelWakeupThread( playThread );
			return 0;
			break;
		}
	}

	//----- t@Cw肳Ă -----

	if (data->running == 0) {									// ĐȂ~
		audioStop();
	}

	if (data->running == 1) {									// Đ
		if (path == NULL) {										// t@Cw肳ĂȂ̂BGMtH_
			strcpy( data->startDir, s2ch.cfg.bgmDir );
			strcpy( data->playDir, s2ch.cfg.bgmDir );
			data->playName[0] = '\0';
			data->running = 3;
			audioPlayEnd();										// Đt@C
		} else {												// w肳ꂽt@CʒuZbg
			strcpy( data->startDir, path );
			strcpy( data->playDir, path );
			strcpy( data->playName, name );
		}
	}
	data->running = 2;
	sceKernelStartThread( playThread, sizeof(mp3_data**), &data );
	data->running = 0;
	sceKernelWakeupThread( playThread );
	return 0;
}


//==============================================================
// Đ~
//--------------------------------------------------------------

void audioStop(void)
{
	mp3_data	*data = &playData;
	int			temp = data->running;

	if (data->running != 1) {
		data->running = 1;
    	if (temp == 2) {
    		sceKernelWakeupThread( playThread );
    	}
    	sceKernelWaitThreadEnd( playThread, NULL );
	}
	data->playDir[0] = '\0';
	data->playName[0] = '\0';
	s2ch.bgmFile[0] = '\0';
	bgmPropertyClear( &gBGM );
}


//==============================================================
// ̋
//--------------------------------------------------------------

void audioNext(void)
{
	mp3_data	*data = &playData;

	if (data->running == 1) {									// ~Ȃ
		strcpy( data->startDir, s2ch.cfg.bgmDir );
		strcpy( data->playDir, s2ch.cfg.bgmDir );
		data->playName[0] = '\0';
		data->running = 4;
		audioPlayEnd();											// Đt@C
		data->running = 2;
		sceKernelStartThread( playThread, sizeof(mp3_data**), &data );
		data->running = 0;
		sceKernelWakeupThread( playThread );
		return;

	} else if (data->running == 2) {							// ꎞ~Ȃ
		data->running = 1;
		sceKernelWakeupThread( playThread );
	}

	data->running = 4;											// ̋Ȃ
}


//==============================================================
// Ő
//--------------------------------------------------------------

void audioBack(void)
{
	mp3_data	*data = &playData;

	if (data->running == 1) {									// ~Ȃ
		strcpy( data->startDir, s2ch.cfg.bgmDir );
		strcpy( data->playDir, s2ch.cfg.bgmDir );
		data->playName[0] = '\0';
		data->running = 5;
		audioPlayEnd();											// Đt@C
		data->running = 2;
		sceKernelStartThread( playThread, sizeof(mp3_data**), &data );
		data->running = 0;
		sceKernelWakeupThread( playThread );
		return;

	} else if (data->running == 2) {							// ꎞ~
		data->running = 1;
		sceKernelWakeupThread( playThread );
	}

	data->running = 5;											// ŐȂ
}


//==============================================================
// ŏĐ
//--------------------------------------------------------------

void audioReplay(void)
{
	mp3_data	*data = &playData;

	if (data->running == 1) {									// ~Ȃ
		audioPlay( NULL, NULL );
		return;

	} else if (data->running == 2) {							// ꎞ~Ȃ
		data->running = 6;
		sceKernelWakeupThread( playThread );
	}

	data->running = 6;											// Ȃ̎n߂
}


//==============================================================
// Đ󋵂̎擾
//--------------------------------------------------------------
// ߂lF0 Đ
//         1 ~
//         2 ꎞ~
//         3 ĐI
//--------------------------------------------------------------

int audioGetPlayMode(void)
{
	mp3_data	*data = &playData;

	return (data->running);
}


//==============================================================
// I
//--------------------------------------------------------------

void audioTerm(void)
{
	mp3_data	*data = &playData;

	if (data->running != 1) {
		audioStop();
	}
	if (decodeThread > 0) {
		sceKernelDeleteThread( decodeThread );
	}
	if (playThread > 0) {
		sceKernelDeleteThread( playThread );
	}
	sceUtilityUnloadModule( PSP_MODULE_AV_AVCODEC );
	sceUtilityUnloadModule( PSP_MODULE_AV_MP3 );
	bgmPropertyClear( &gBGM );
}


