#ifndef _RAR_ARCHIVE_
#define _RAR_ARCHIVE_

class Pack;

enum {EN_LOCK=1,EN_VOL=2,EN_FIRSTVOL=4};

class Archive:public File
{
  private:
    bool IsSignature(byte *D);
    void UpdateLatestTime(FileHeader *CurBlock);
    void ConvertNameCase(char *Name);
    void ConvertNameCase(wchar *Name);
    void ConvertUnknownHeader();
    int ReadOldHeader();

    CryptData HeadersCrypt;
    byte HeadersSalt[SALT_SIZE];
    ComprDataIO SubDataIO;
    byte SubDataSalt[SALT_SIZE];
    RAROptions *Cmd,DummyCmd;

    MarkHeader MarkHead;
    OldMainHeader OldMhd;

    int RecoverySectors;

    int CurHeaderType;

    bool SilentOpen;
  public:
    Archive(RAROptions *InitCmd=NULL);
    bool IsArchive(bool EnableBroken);
    int SearchBlock(int BlockType);
    int SearchSubBlock(const char *Type);
    int ReadHeader();
    void CheckArc(bool EnableBroken);
    bool GetComment(Array<byte> *CmtData);
    void SeekToNext();
    bool IsArcDir();
    bool IsArcLabel();
    bool ReadSubData(Array<byte> *UnpData);
    int GetHeaderType() {return(CurHeaderType);};
    int ReadCommentData(Array<byte> *CmtData);
    RAROptions* GetRAROptions() {return(Cmd);}

    BaseBlock ShortBlock;
    MainHeader NewMhd;
    FileHeader NewLhd;
    EndArcHeader EndArcHead;
    SubBlockHeader SubBlockHead;
    FileHeader SubHead;
    CommentHeader CommHead;
    ProtectHeader ProtectHead;
    AVHeader AVHead;
    SignHeader SignHead;
    UnixOwnersHeader UOHead;
    MacFInfoHeader MACHead;
    EAHeader EAHead;
    StreamHeader StreamHead;

    Int64 CurBlockPos;
    Int64 NextBlockPos;

    bool OldFormat;
    bool Solid;
    bool Volume;
    bool MainComment;
    bool Locked;
    bool Signed;
    bool NotFirstVolume;
    bool Protected;
    bool Encrypted;
    uint SFXSize;
    bool BrokenFileHeader;
    ushort HeaderCRC;

    char FirstVolumeName[NM];
    wchar FirstVolumeNameW[NM];
};

#endif
