#include "rar.hpp"
#include "global.hpp"

static bool UserBreak;

ErrorHandler::ErrorHandler()
{
  Clean();
}


void ErrorHandler::Clean()
{
  ExitCode=SUCCESS;
}


void ErrorHandler::MemoryError()
{
  Throw(MEMORY_ERROR);
}

void ErrorHandler::CloseError(const char *FileName)
{
  Throw(FATAL_ERROR);
}


void ErrorHandler::ReadError(const char *FileName)
{
  Throw(FATAL_ERROR);
}

void ErrorHandler::SeekError(const char *FileName)
{
  Throw(FATAL_ERROR);
}

void ErrorHandler::Exit(int ExitCode)
{
  Throw(ExitCode);
}

void ErrorHandler::SetErrorCode(int Code)
{
  switch(Code)
  {
    case WARNING:
    case USER_BREAK:
      if (ExitCode==SUCCESS)
        ExitCode=Code;
      break;
    case FATAL_ERROR:
      if (ExitCode==SUCCESS || ExitCode==WARNING)
        ExitCode=FATAL_ERROR;
      break;
    default:
      ExitCode=Code;
      break;
  }
}

void ErrorHandler::Throw(int Code)
{
  ErrHandler.SetErrorCode(Code);
  throw Code;
}
