#include "rar.hpp"
#include "global.hpp"
#include "strlist.hpp"
#include "strfn.hpp"
#include "unicode.hpp"

StringList::StringList()
{
  Reset();
}


StringList::~StringList()
{
}


void StringList::Reset()
{
  Rewind();
  StringData.Reset();
  StringDataW.Reset();
  PosDataW.Reset();
  StringsCount=0;
  SavePosNumber=0;
}


unsigned int StringList::AddString(const char *Str)
{
  int PrevSize=StringData.Size();
  StringData.Add(strlen(Str)+1);
  strcpy(&StringData[PrevSize], Str);
  StringsCount++;
  return PrevSize;
}

bool StringList::GetStringB(char *Str, int MaxLength)
{
  char *StrPtr;
  wchar *StrPtrW;
  if (Str==NULL || !GetStringD(&StrPtr,&StrPtrW))
    return(false);
  strncpy(Str,StrPtr,MaxLength);
  return(true);
}


bool StringList::GetStringC(char *Str, int MaxLength, int StringNum)
{
  SavePosition();
  Rewind();
  bool RetCode=true;
  while (StringNum-- >=0)
    if (!GetStringB(Str, MaxLength))
    {
      RetCode=false;
      break;
    }
  RestorePosition();
  return(RetCode);
}


char* StringList::GetStringA()
{
  char *Str;
  GetStringD(&Str,NULL);
  return(Str);
}



bool StringList::GetStringD(char **Str,wchar **StrW)
{
  if (CurPos>=StringData.Size())
  {
    *Str=NULL;
    return(false);
  }
  *Str=&StringData[CurPos];
  if (PosDataItem<PosDataW.Size() && PosDataW[PosDataItem]==CurPos)
  {
    PosDataItem++;
    if (StrW!=NULL)
      *StrW=&StringDataW[CurPosW];
    CurPosW+=strlenw(&StringDataW[CurPosW])+1;
  }
  else
    if (StrW!=NULL)
      *StrW=NULL;
  CurPos+=strlen(*Str)+1;
  return(true);
}

void StringList::Rewind()
{
  CurPos=0;
  CurPosW=0;
  PosDataItem=0;
}

void StringList::SavePosition()
{
  if (SavePosNumber<sizeof(SaveCurPos)/sizeof(SaveCurPos[0]))
  {
    SaveCurPos[SavePosNumber]=CurPos;
    SaveCurPosW[SavePosNumber]=CurPosW;
    SavePosDataItem[SavePosNumber]=PosDataItem;
    SavePosNumber++;
  }
}

void StringList::RestorePosition()
{
  if (SavePosNumber>0)
  {
    SavePosNumber--;
    CurPos=SaveCurPos[SavePosNumber];
    CurPosW=SaveCurPosW[SavePosNumber];
    PosDataItem=SavePosDataItem[SavePosNumber];
  }
}
