#ifndef _RAR_TIMEFN_
#define _RAR_TIMEFN_

#include "int64.hpp"

struct RarLocalTime
{
  uint Year;
  uint Month;
  uint Day;
  uint Hour;
  uint Minute;
  uint Second;
  uint Reminder;
  uint wDay;
  uint yDay;
};


class RarTime
{
  private:
    Int64 GetRaw();
    RarLocalTime rlt;

    Int64 Time;
  public:
    RarTime();
    RarTime& operator =(time_t ut);
    time_t GetUnix();
    bool operator == (RarTime &rt);
    bool operator < (RarTime &rt);
    bool operator <= (RarTime &rt);
    bool operator > (RarTime &rt);
    bool operator >= (RarTime &rt);
    void GetLocal(RarLocalTime *lt) {*lt=rlt;}
    void SetLocal(RarLocalTime *lt) {rlt=*lt;}
    uint GetDos();
    void SetDos(uint DosTime);
    void Reset() {rlt.Year=0;}
    bool IsSet() {return(rlt.Year!=0);}
};

#endif
